

function GTDGmail_InboxData(){
	this.EmailsArray = new Array();
	this.EmailData = new Object();

	this.emailDataLength = 0;

	this.prefixProject = GTDGmail_Common.SharedObj.LabelTypesObj.Project.prefix;
	this.prefixContext = GTDGmail_Common.SharedObj.LabelTypesObj.Context.prefix;
	this.prefixStatus = GTDGmail_Common.SharedObj.LabelTypesObj.Status.prefix;
}
GTDGmail_InboxData.prototype.addEmail = function(LabelsArray, subject, emailIntro, date, hasStar){
	/*
		Create new entry in EmailsArray
		Add row to EmailData
			ProjectsArray
			ContextsArray
			StatusesArray
			ReferencesArray
	*/
	
	// Create an ID for this email:
	
	
	try{
					
			var e = this.emailDataLength;
			this.EmailData[e] = new Object();
			//alert("new: " + e + "\n" + subject + "\n" + emailIntro);
			try{
					// It's not a finished item
					
					this.EmailData[e].ProjectsArray = new Array();
					this.EmailData[e].ContextsArray = new Array();
					this.EmailData[e].StatusesArray = new Array();
					this.EmailData[e].subject = subject;
					this.EmailData[e].emailIntro = emailIntro;
					this.EmailData[e].hasStar = hasStar;
					this.EmailData[e].date = date;
					
					// Extract labels by type from LabelsArray
					for( var i = 0; i < LabelsArray.length; i++ ){
						if( LabelsArray[i].indexOf( this.prefixProject )==0 ){
							// It's a project
							this.EmailData[e].ProjectsArray[ this.EmailData[e].ProjectsArray.length ] = LabelsArray[i];
						}else{
							if( LabelsArray[i].indexOf( this.prefixContext )==0 ){
								// It's a project
								this.EmailData[e].ContextsArray[ this.EmailData[e].ContextsArray.length ] = LabelsArray[i];
							}else{
								if( LabelsArray[i].indexOf( this.prefixStatus )==0 ){
									// It's a status
									this.EmailData[e].StatusesArray[ this.EmailData[e].StatusesArray.length ] = LabelsArray[i];
								}
							}
						}
					}
			}catch(e){
				//alert(e.toString());
			}
			this.emailDataLength++;
			
	}catch(e){
		//alert(e.toString());
	}
}
GTDGmail_InboxData.prototype.prvArrayContains = function(TestArray, findStr){
	for( var ii = 0; ii < TestArray.length; ii++ ){
		if( TestArray[ii]==findStr ){
			return true;
		}
	}
	return false;
}
GTDGmail_InboxData.prototype.getProjects = function(){
	/*
		Scan the EmailData object, building an array of unique projects, and return it
	*/
		
	var ProjectsArray = new Array();
	
	for( var i = 0; i < this.emailDataLength; i++ ){
		if( this.EmailData[i] ){
			for( var j = 0; j < this.EmailData[i].ProjectsArray.length; j++ ){
				if( !this.prvArrayContains( ProjectsArray, this.EmailData[i].ProjectsArray[j] ) ){
					ProjectsArray[ ProjectsArray.length ] = this.EmailData[i].ProjectsArray[j];
				}
			}
		}
	}
	
	return ProjectsArray;
}
GTDGmail_InboxData.prototype.getContexts = function(){

	var ContextsArray = new Array();
	
	for( var i = 0; i < this.emailDataLength; i++ ){
		if( this.EmailData[i] ){
			for( var j = 0; j < this.EmailData[i].ContextsArray.length; j++ ){
				if( !this.prvArrayContains( ContextsArray, this.EmailData[i].ContextsArray[j] ) ){
					ContextsArray[ ContextsArray.length ] = this.EmailData[i].ContextsArray[j];
				}
			}
		}
	}
	
	return ContextsArray;
}
GTDGmail_InboxData.prototype.getStatuses = function(){

	var StatusesArray = new Array();
	
	for( var i = 0; i < this.emailDataLength; i++ ){
		if( this.EmailData[i] ){
			for( var j = 0; j < this.EmailData[i].StatusesArray.length; j++ ){
				if( !this.prvArrayContains( StatusesArray, this.EmailData[i].StatusesArray[j] ) ){
					StatusesArray[ StatusesArray.length ] = this.EmailData[i].StatusesArray[j];
				}
			}
		}
	}
	
	return StatusesArray;
}
GTDGmail_InboxData.prototype.getEmailIds = function(){

	var EmailIdsArray = new Array();
	
	for( var i = 0; i < this.emailDataLength; i++ ){
		if( this.EmailData[i] ){
			var doInclude = false;
			if( this.EmailData[i].ProjectsArray.length > 0 ) doInclude = true;
			if( this.EmailData[i].StatusesArray.length > 0 ) doInclude = true;
			if( this.EmailData[i].ContextsArray.length > 0 ) doInclude = true;
			
			if( doInclude ){
				EmailIdsArray[ EmailIdsArray.length ] = i;
			}
		}
	}
	
	return EmailIdsArray;
}
GTDGmail_InboxData.prototype.getStatusesByContextOrProject = function(contextLabel, projectLabel){
	/*
		Data Type:
		ContextObj.FoundStatusesArray = []	//found statuses with this context
		ContextObj[Status] = []				//found email ids with this Status and Context
		
		Process Each Email
			If context matches, add any status to FoundStatusesArray
				Add email to ContextObj, filed under any statuses, e.g. ContextObj[Status] = [ID]
	*/
	
	try{
		
		
		var StatusObj = new Object();
		StatusObj.FoundStatusesArray = new Array();
		
		for( var i = 0; i < this.emailDataLength; i++ ){
			if( this.EmailData[i] ){
				
					// See if this Email has satisfies context restriction
					if( contextLabel=="" || this.prvArrayContains( this.EmailData[i].ContextsArray, contextLabel ) ){
						// Okay, we have a matching context
										
						// Verify no project restrictions:
						if( !projectLabel || projectLabel=="" || this.prvArrayContains( this.EmailData[i].ProjectsArray, projectLabel ) ){
							
							var hasStatus = false;
							
							if( this.EmailData[i].StatusesArray.length > 0 ){
								// And this email has statuses
								
								// Process each Status, adding this emailID to StatusObj[Status] array
								for( var j = 0; j < this.EmailData[i].StatusesArray.length; j++ ){
									var statusLbl = this.EmailData[i].StatusesArray[j]
									if( !StatusObj[ statusLbl ] ){
										StatusObj[ statusLbl ] = new Array();
										StatusObj.FoundStatusesArray[ StatusObj.FoundStatusesArray.length ] = statusLbl;
									}
									// Add this email id to the end of the array:
									StatusObj[statusLbl][ StatusObj[statusLbl].length ] = i;
									hasStatus = true;
								}
							}
							if( !hasStatus ){
								// Give it a Misc. status
								if(!StatusObj.Misc){
									StatusObj.Misc = new Array();
									StatusObj.FoundStatusesArray[ StatusObj.FoundStatusesArray.length ] = "Misc";
								}
								StatusObj.Misc[ StatusObj.Misc.length ] = i;
							}
						}
					}
			}
		}
	}catch(e){
		//alert(e.toString());
	}
	
	
	
	return StatusObj;
}




