
var GTDGmail_NavBar = {

	closedLabelsBoxCount: 0,
	
	pageHasFreshNavBar: function(){
		/*
			Return true if this page both has the Nav Bar, 
				AND the Nav Bar has not been altered.
		*/
		
		var ElNavBoxLabels = document.getElementById("nb_0");
		
				
		if( ElNavBoxLabels ){
			ElNavBoxLabels = null;
			return true;
		}else{
			ElNavBoxLabels = null;
			return false;
		}
	},
	
	addRefreshHooks: function(){
		/*
			Update existing elements to have an onclick, that causes a refresh
			The refresh is on a timeout
			Targets for onclick:
				Compose
				Inbox...
				Labels show/hide
		*/
		
		// NO!
		return;
		
		var onclickStr = "GTDGmail_NavBar.initRefresh();";
		
		/* Inbox...
			Retrieve element with the ID 'nds'
				Establish a Treewalker over it
				For any item with an ID starting 'ds_', apply the onclick command
		*/
		var ElNds = document.getElementById("nds");
		var tw = document.createTreeWalker(ElNds, ~NodeFilter.SHOW_COMMENT, null, false);
		for(var childNode = tw.firstChild(); childNode!=null; childNode = tw.nextNode()){
			if( childNode.id && childNode.id.indexOf("ds_")!=-1 ){
				var oldOnclick = childNode.getAttribute("onclick");
				if( !oldOnclick || oldOnclick==null || oldOnclick=="" ){
					oldOnclick = "";
				}
				if( oldOnclick.indexOf( onclickStr )==-1 ){
					childNode.setAttribute("onclick", onclickStr + oldOnclick);
				}
			}
		}
		
		/*
			Labels
			Grab nt_0
		*/
		var ElLabelsHeader = document.getElementById("nt_0");
		var oldOnclick = ElLabelsHeader.getAttribute("onclick");
		if( !oldOnclick || oldOnclick==null || oldOnclick=="" ){
			oldOnclick = "";
		}
		if( oldOnclick.indexOf( onclickStr )==-1 ){
			ElLabelsHeader.setAttribute("onclick", onclickStr + oldOnclick);
		}
		
		
	},
	initRefresh: function(){
		setTimeout("GTDGmail_NavBar.handleLabels();", 500);
		setTimeout("GTDGmail_NavBar.handleLabels();", 1000);
		setTimeout("GTDGmail_NavBar.handleLabels();", 3000);
		
	},
	
	handleLabels: function(bool_AfterOpenCloseLabelsBox){
		/*
			Retrieve the label box
			Process the labels one by one
				Add them to the Shared Object
			Insert Breaks (Projects:, Contexts:, etc.)
				When a prefix changes, insert the correct Type the element before
			Handle Old Labels
				If an 'Old' prefix is found, pull the label out, and attached to a new Div
				If this Div has labels, apply to to the end of labels box (hidden)
		*/
		
		//var eTimer = new ExecutionTimer("HandleLabels");
		//eTimer.start();

		GTDGmail_Common.grabAndStoreEmailAddress();

		try{		

			if( !document.getElementById("NavBox_Labels_Marker_Complete") ){	// Test not already processed

				var elNavBar = document.getElementById("nb_0");
				var ElLastLabel_EditLabel = this.getLabelsBoxLastElement(elNavBar);
				if( !bool_AfterOpenCloseLabelsBox ){ // Do not keep opening closing
					if( this.closedLabelsBoxCount==0 && !ElLastLabel_EditLabel ){
						// Cannot see labels, try to pop them open
						var ElNavBarHeader = document.getElementById("nt_0");
						GTDGmail_Common.doMouseEvent(ElNavBarHeader, "mousedown");
						
						ElNavBar = null;
						// Reload, see if its available
						this.handleLabels(true);
					}
					this.closedLabelsBoxCount++;
					if( this.closedLabelsBoxCount > 15 ){
						this.closedLabelsBoxCount = 0;
					}
				}
				if( ElLastLabel_EditLabel ){
					try{
					
						var alterLabels = GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.Labels", false);
						
						
							if( ElLastLabel_EditLabel ){
								// Will not be there if Labels hidden
								
								// Get Head of Labels:
								var ElLabelsParent = ElLastLabel_EditLabel.parentNode;
								//alert(ElLabelsParent.id);
											
								// Hold old items:
								var ElOldLabels = document.createElement("DIV");
								
								
								var useStar = GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false);
								
								var firstOne = true;
								var firstMiscLabel = true;
								var incMisc = GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.IncMiscLabels", false);
								if( !incMisc ){
									// Clear array:
									GTDGmail_Common.SharedObj.LabelsObj.Misc.LabelArray = null;
									GTDGmail_Common.SharedObj.LabelsObj.Misc.LabelArray = new Array();
								}
								//var lastPrefix = "";
								var lastType = "";
								var Types = ["Context", "Status", "Project", "Reference", "Old"];
								//var FoundTypesArray = new Array();	// Keep track of Types that are found; then clear the array of those that are not
								
								var TypeBucket = new Object();
								TypeBucket.FoundTypesArray = new Array();
								
								// Process the Labels in Reverse:
									for( var i = 0; i < ElLabelsParent.childNodes.length; i++ ){
										if( ElLabelsParent.childNodes[i].id.indexOf("sc_")!=-1 || ElLabelsParent.childNodes[i].id.indexOf("sgtdc_")!=-1 ){
											// It's a label
											var labelId = ElLabelsParent.childNodes[i].id.replace(/^(\w+)_/, "");
											
											var hasPrefix = false;
											// See if label Type (prefix) has changed:
											for( var j = 0; j < Types.length; j++ ){
												var typeStr = Types[j];
												var prefixStr = GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].prefix;
												if( labelId.indexOf( prefixStr )==0 ){
													// This is prefixed
													hasPrefix = true;
													
													if( typeStr=="Old" ){
														// Attach it to ElOldLabels
														if( alterLabels ){
															ElOldLabels.appendChild( ElLabelsParent.childNodes[i] );
														}
													}else{
														if( useStar && GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction==labelId ){
															// Use is starred
															ElLabelsParent.childNodes[i].id = "sgtdc_" + labelId;	// Stops Gmail processing it
															var searchStr = "is:starred";
															ElLabelsParent.childNodes[i].setAttribute("onclick", "GTDGmail_SearchBar.doSearch('" + searchStr + "');");
															// Get rid of any tags
															ElLabelsParent.childNodes[i].innerHTML = ElLabelsParent.childNodes[i].innerHTML.replace(/\<([^>]+)\>/g, "");
															ElLabelsParent.childNodes[i].innerHTML = ElLabelsParent.childNodes[i].innerHTML.replace(/\(((\d)+)\)$/, "");
														}
														
															// Override it so it has a click handler - rather than Gmail default
															ElLabelsParent.childNodes[i].id = "sgtdc_" + labelId;	// Stops Gmail processing it
															//var labelName = ElLabelsParent.childNodes[i].innerHTML;	// Get the label name
															var labelNameNoSpace = labelId.replace(/[ &]/g, "-");
															
															var searchStr = "label:" + labelNameNoSpace;														
															// See if we are searching within the email:
															searchStr += GTDGmail_Common.getCommonSearchStr_SearchLabelsInEmail(labelNameNoSpace);
															
															if( typeStr=="Status" ){
																if( useStar && GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction==labelId ){
																	// Use is starred
																	searchStr = searchStr.replace("label:" + labelNameNoSpace, "is:starred");
																}
																searchStr = "(" + searchStr + ")";
																if( GTDGmail_Common.SharedObj.StandardLabels.Status.Finished!=labelId ){
																	// It's not a Finished status, so stipulate label must be finished
																	searchStr += " -label:" + GTDGmail_Common.SharedObj.StandardLabels.Status.Finished.replace(/[ &]/g, "-");
																}
																if( GTDGmail_Common.SharedObj.StandardLabels.Status.Someday==labelId ){
																	// It's a Some Day
																	searchStr += GTDGmail_Common.getCommonSearchTermStr(true);
																}else{
																	searchStr += GTDGmail_Common.getCommonSearchTermStr();
																}
																															
															}
															ElLabelsParent.childNodes[i].setAttribute("onclick", "GTDGmail_SearchBar.doSearch('" + searchStr + "');");
														
														
														
														// See if remove prefix:
														ElLabelsParent.childNodes[i].innerHTML = GTDGmail_Common.removeLabelPrefix_Known(prefixStr, ElLabelsParent.childNodes[i].innerHTML);
														
														
														if( lastType!=typeStr && !GTDGmail_Common.arrayContains(TypeBucket.FoundTypesArray, typeStr) ){
															// Type has changed, not seen it before
															// Add this to Found Types
															// Create a new bucket for this type
															TypeBucket.FoundTypesArray[ TypeBucket.FoundTypesArray.length ] = typeStr;
															TypeBucket[typeStr] = new Object();
															TypeBucket[typeStr].Div = document.createElement("DIV");
															
															lastType = typeStr;
															
															// Clear known labels for this type:
															GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray = new Array();
														}
														
														if( alterLabels ){	
															// Indent it a little
															ElLabelsParent.childNodes[i].style.marginLeft = "10px";
															
															// Add this label to the approriate bucket
															TypeBucket[typeStr].Div.appendChild( ElLabelsParent.childNodes[i] );
															
															if( typeStr=="Project" ){
																// Add Sub Links:
																TypeBucket[typeStr].Div.appendChild( this.getHtml_ProjectSubLinks(labelId) );
															}
															if( typeStr=="Context" ){
																// Add Sub Links:
																TypeBucket[typeStr].Div.appendChild( this.getHtml_ContextSubLinks(labelId) );
															}
														}
														
														
														// Add it to known labels for this type:
														GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray[ GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray.length ] = labelId;
													}
													
													if( alterLabels ){
														i--;
													}
												}						
											}
											if( !hasPrefix ){
												// Not prefixed
												
												// Add it to misc:
												if( firstMiscLabel ){
													GTDGmail_Common.SharedObj.LabelsObj.Misc.LabelArray = new Array();
													firstMiscLabel = false;
												}
												
												if( incMisc ){
													// Add it to the array:
													GTDGmail_Common.SharedObj.LabelsObj.Misc.LabelArray[ GTDGmail_Common.SharedObj.LabelsObj.Misc.LabelArray.length ] = labelId;
												}
											}	
										}
									}
									if( firstMiscLabel ){
										// No Misc labels ever found
										GTDGmail_Common.SharedObj.LabelsObj.Misc.LabelArray = new Array();
									}
									
									if( alterLabels ){
										var ElHookPointLabels = ElLastLabel_EditLabel;
										if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.InsertAboveNormalLabels", false) ){
											ElHookPointLabels = ElHookPointLabels.parentNode.firstChild;
										}
										// Process the Buckets:
										// If the Div has innerHTML, give it a header, append it to the Labels bar#
										if( TypeBucket.FoundTypesArray.length > 0 ){
											var ElSpan = document.createElement("SPAN");
											ElSpan.className = "GTDLabelBox_Type_DisplayName";
											if( !GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.InsertAboveNormalLabels", false) ){
												ElSpan.innerHTML += "<br/>";
											}
											//ElSpan.innerHTML += "<strong>GTD</strong>";
											ElLabelsParent.insertBefore( ElSpan, ElHookPointLabels);
										}
										
										var firstStatusId = "";
										var ReverseFoundTypesArray = TypeBucket.FoundTypesArray.reverse();
										for( var i = 0; i < Types.length; i++ ){
											var typeStr = Types[i];
																	
											if( GTDGmail_Common.arrayContains(TypeBucket.FoundTypesArray, typeStr) ){
												// This Type was Found
												if( typeStr.toLowerCase()=="status" ){
													firstStatusId = TypeBucket[typeStr].Div.firstChild.id;
													//TypeBucket[typeStr].Div.innerHTML = GTDGmail_Common.renderStandardStatuses_InOrder("<div class='lk cs' style='margin-left: 10px' id=\"sgtdc_<!StatusLabel!>\" onclick=\"GTDGmail_SearchBar.doSearch(\'label:<!StatusLabelEncodeQuotesNoSpace!><!SearchLabelInEmailEncodeQuotesNoSpace!>\');\"><!StatusLabel!></div>", "", true, null);
												}
												if( typeStr.toLowerCase()!="old" ){
													if( TypeBucket[typeStr].Div.innerHTML!="" ){
														// It has content, give it a header:
														var spanStr = "<SPAN id='gtdType_" + typeStr + "' class='GTDLabelBox_Type_DisplayName' title='" + GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].toolTip + "'>";
														spanStr += GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].displayName;
														//spanStr += "&nbsp;<span style='font-size:0.8em;color:#999999;' title='" + GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].toolTip + "'>?</span>";
														spanStr += "</SPAN>";
														
														if( firstOne ){
															//spanStr = "<br/>" + spanStr;
															firstOne = false;
														}
														TypeBucket[typeStr].Div.innerHTML = spanStr + TypeBucket[typeStr].Div.innerHTML;
													}
													
													// Append the Div to the end of the Labels box:
													ElLabelsParent.insertBefore( TypeBucket[typeStr].Div, ElHookPointLabels);
												}
											}else{
												// This type was not found, wipe the array
												GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray = new Array();
											}			
										}
										if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.InsertAboveNormalLabels", false) ){
											// Insert a spacer
											var ElDiv = document.createElement("DIV");
											ElDiv.innerHTML = "&nbsp;";
											ElLabelsParent.insertBefore( ElDiv, ElHookPointLabels);
											
											ElDiv = null;
										}
										if( firstStatusId ){
											/* Re-Order Statuses:
												For each default status in reverse order, pick out element in Labels (id: sgtdc_<label>)
												Re insert them above the previous sibling of the first status
											*/
											var ElFirstStatus = document.getElementById(firstStatusId);
											ElFirstStatus = ElFirstStatus.previousSibling; // more stable -statuses are being moved
											for( var i = GTDGmail_Common.SharedObj.StandardLabels.Status.StatusArray.length - 1; i >= 0; i-- ){
												var statusId = GTDGmail_Common.SharedObj.StandardLabels.Status.StatusArray[i];
												var statusLabel = GTDGmail_Common.SharedObj.StandardLabels.Status[statusId];
												
												var ElStatus = document.getElementById("sgtdc_" + statusLabel);
												if( !ElStatus ){
													ElStatus = document.getElementById("sc_" + statusLabel);
												}
												if( ElStatus ){
													ElFirstStatus.parentNode.insertBefore( ElStatus, ElFirstStatus.nextSibling );
												}
												ElStatus = null;
											}
										}
										
										ElHookPointLabels = null;
									}
									
													
									
									
									// Mark it complete:
									var ElMarker = document.createElement("SPAN");
									ElMarker.id = "NavBox_Labels_Marker_Complete";
									ElMarker.innerHTML = " ";
									//ElMarker.style.display = "none";
									ElLabelsParent.insertBefore( ElMarker, ElLastLabel_EditLabel);
								
								
								if( alterLabels ){
									if( ElOldLabels.childNodes.length > 0 ){
										/*  There are child nodes to add in
											Create a elements to Show/Hide to old labels (a wrapper)
											<DIV>
												<a Show> <a Hide [hidden]><br/>
												<DIV OldLabels>
										*/
										var ElDivWrapper = document.createElement("DIV");
										ElDivWrapper.innerHTML = "<br/><a id='Link_GTDLabelBox_Type_OldLabels' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='show' elToShowHide='Div_GTDLabelBox_OldLabels' textShow='Show Old Labels &#187;' textHide='Hide Old Labels' class='GTDLabelBox_Type_OldLabels'>Show Old Labels&#187;</a><br/>";
										ElOldLabels.id = "Div_GTDLabelBox_OldLabels";
										ElOldLabels.style.display = "none";
										ElDivWrapper.appendChild(ElOldLabels);
										ElLabelsParent.insertBefore( ElDivWrapper, ElLastLabel_EditLabel );
									}
								}
								
								ElLabelsParent = null;
								ElOldLabels = null;
								Types = null;
								TypeBucket = null;
								ElHookPointLabels = null;
								
							}else{
							}
											
					}catch(e){
						//alert(e.toString() + "\nGTDGmail_NavBar");
					}
				}
				
				elNavBar = null;
				ElLastLabel_EditLabel = null;
				
				if( bool_AfterOpenCloseLabelsBox==true ){
					// Close Labels box - we opened it just to get the contents out
					var ElNavBarHeader = document.getElementById("nt_0");
					GTDGmail_Common.doMouseEvent(ElNavBarHeader, "mousedown");
					
					ElNavBarHeader = null;
				}
				
			
				//eTimer.stop();
				//eTimer.announce();
				//eTimer.start();
				
				GTDGmail_NavBar.addGTDNavBoxes();
				
				// See if anything to show:
				GTDGmail_Common.hideShowHideElements();
				
				if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDNotices", false) ){
					GTDGmail_NavBar.addGTDNavBoxes_NoticeBox();		// SHOULD DO AFTER SHOWHIDE
				}
				
				//eTimer.stop();
				//eTimer.announce();
				
				//GTDGmail_NavBar.addRefreshHooks();
			}

		}catch(e){
			//alert(e.toString() + "\nGTDGmail_NavBar");
		}
		
		/*
		if( this.pageHasFreshNavBar()==true && bool_keepRefreshing==true ){
			// Only proceed if we still have the elements:
			
			if( numberTimesProcessedInt<6 ){
				setTimeout("GTDGmail_NavBar.handleLabels(" + (numberTimesProcessedInt + 1) + ", true);", 2000);
			}else{
				if( numberTimesProcessedInt > 100 ){
					numberTimesProcessedInt = 10;
				}
				setTimeout("GTDGmail_NavBar.handleLabels(" + (numberTimesProcessedInt + 1) + ", true);", 6000);
			}
		}
		*/
		
	},
	getLabelsBoxLastElement: function(ElNavBar){
		var ElLastLabel_EditLabel = null;
		var tw = document.createTreeWalker(ElNavBar, NodeFilter.SHOW_ELEMENT, null, false);
		for(var childNode = tw.firstChild(); childNode!=null; childNode = tw.nextNode()){
			if( childNode.id=="prf_l" ){
				ElLastLabel_EditLabel = childNode;
				break;
			}
		}
		
		return ElLastLabel_EditLabel;
	},
	getHtml_ProjectSubLinks: function(labelProject){
		/*
			For each project, create a DIV
			In this DIV, place 3 links: ProjectHome, Actions, References
				Home: label:<project> AND label:C:ProjectHome
				Actions: label:<project> AND (label:S:Next-Action OR label:S:Action)
				References: label:<project> AND (label:R:Reference OR ....)	 <- for all references
		*/
		try{
			var ElDiv = document.createElement("DIV");
			ElDiv.className = "GTDLabelBox_Project_SubLinks";
			
			
			
			labelProject = labelProject.replace(/[ &]/g, "-");
			
			var labelProjectHome = GTDGmail_Common.SharedObj.StandardLabels.Reference.ProjectHome.replace(/[ &]/g, "-");
			var labelNextAction = GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction.replace(/[ &]/g, "-");
			var labelFinished = GTDGmail_Common.SharedObj.StandardLabels.Status.Finished.replace(/[ &]/g, "-");


			var labelsInEmailsStr = GTDGmail_Common.getCommonSearchStr_SearchLabelsInEmail(labelProject);		
			
			var labelAction = GTDGmail_Common.SharedObj.StandardLabels.Status.Action.replace(/[ &]/g, "-");
			
			var innerHTML = "";
			/*
			innerHTML += "<a href='' title=\"See this Project's Hompage\" onclick=\"GTDGmail_SearchBar.doSearch('label:" + labelProject + " label:" + labelProjectHome + "');return false;\">";
			innerHTML += "Home";
			innerHTML += "</a> - ";
			*/
			
			innerHTML += this.getHtml_SubLinks_Link("Next Actions", "See Next Actions for this Project", "", "(label:" + labelProject + labelsInEmailsStr + ") label:" + labelNextAction + " -label:" + labelFinished, false);
			innerHTML += " - ";
					
			innerHTML += this.getHtml_SubLinks_Link("Actions", "See all of this Project's Unfinished Actions", "See all of this Project's Actions", "label:" + labelProject + labelsInEmailsStr + " (label:" + labelNextAction + " OR label:" + labelAction + ")", true);
			//innerHTML += " - ";
							
			
			var referenceLabels = "";
			for( var i = 0; i < GTDGmail_Common.SharedObj.LabelsObj.Reference.LabelArray.length; i++ ){
				var refLabel = GTDGmail_Common.SharedObj.LabelsObj.Reference.LabelArray[i];
				refLabel = refLabel.replace(/[ &]/g, "-");
				
				if( referenceLabels!="" ){
					referenceLabels = referenceLabels + " OR ";
				}
				referenceLabels += "label:" + refLabel;
			}
			if( referenceLabels!="" ){
				innerHTML += "<br/>";
				innerHTML += this.getHtml_SubLinks_Link("References", "See all of this Project's References", "See all of this Project's References", "label:" + labelProject + " (" + referenceLabels + ")", false);
			}

			if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false) ){
				innerHTML = GTDGmail_Common.replaceAll(innerHTML, "label:" + labelNextAction, "is:starred");
			}
			
			ElDiv.innerHTML = innerHTML;
			
			return ElDiv;
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_NavBar");
		}
	},
	getHtml_ContextSubLinks: function(labelContext){
		/*
			For each context, create a DIV
			In this DIV, place 3 links: Next Actions, Actions (*)
				Next Actions: label:<project> label:S:Next-Action -label:S-Finished
				Actions: label:<project> AND (label:S:Next-Action OR label:S:Action)
		*/
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "GTDLabelBox_Project_SubLinks";
		
		
		
		labelContext = labelContext.replace(/[ &]/g, "-");
		
		var labelNextAction = GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction.replace(/[ &]/g, "-");
		var labelAction = GTDGmail_Common.SharedObj.StandardLabels.Status.Action.replace(/[ &]/g, "-");
		var labelFinished = GTDGmail_Common.SharedObj.StandardLabels.Status.Finished.replace(/[ &]/g, "-");
		
		
		var labelsInEmailsStr = GTDGmail_Common.getCommonSearchStr_SearchLabelsInEmail(labelContext);
		
		var innerHTML = "";
		innerHTML += this.getHtml_SubLinks_Link("Next Actions", "See Next Actions for this Context", "", "(label:" + labelContext + labelsInEmailsStr + ") label:" + labelNextAction + " -label:" + labelFinished, false);
		innerHTML += " - ";
		
		
		innerHTML += this.getHtml_SubLinks_Link("Actions", "See Unfinished Actions for this Context", "See All Actions for this Context", "(label:" + labelContext + labelsInEmailsStr + ") (label:" + labelNextAction + " OR label:" + labelAction + ")" + " -label:" + labelFinished, false);
		
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false) ){
			innerHTML = GTDGmail_Common.replaceAll(innerHTML, "label:" + labelNextAction, "is:starred");
		}
		
		ElDiv.innerHTML = innerHTML;
		
		return ElDiv;
	},
	getHtml_SubLinks_Link: function(name, title, titleIncFinished, searchStr, bool_useDualityAsterisk){
		try{
			searchStr = GTDGmail_Common.encodeQuotes(searchStr);
			
			var xtraSearchStr = GTDGmail_Common.getCommonSearchTermStr();
			
			var searchStr1 = searchStr;
			if( bool_useDualityAsterisk ){
				// Cannot have S:Finished tag for first one (Only unfinished items)
				searchStr1 = "(" + searchStr1 + ") -label:" + GTDGmail_Common.SharedObj.StandardLabels.Status.Finished.replace(/[ &]/g, "-");
			}		
			
			var innerHTML = "<a href='' title=\"" + title + "\" onclick=\"GTDGmail_SearchBar.doSearch('" + searchStr1 + xtraSearchStr + "');return false;\">";
			innerHTML += name;
			innerHTML += "</a> ";
			
			if(bool_useDualityAsterisk){
				// And Including Finished as Asterisk
				innerHTML += "<a href='' title=\"" + titleIncFinished + "\" onclick=\"GTDGmail_SearchBar.doSearch('" + searchStr + xtraSearchStr + "');return false;\">";
				innerHTML += "*";
				innerHTML += "</a>";
			}
			
			
			return innerHTML;
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_NavBar");
		}
	},
	
	
	
	addGTDNavBoxes: function(){
		/*
			Create the various Nav Boxes for GTD (if they don't exist)
			GTD Review
				Box of search commands to see Type Items over a week old
			GTD Help
				The project box
		*/
		
		/* =====
			GTD Review and GTD Add to Search
		==== */

		var ElTopNavContainer = document.getElementById("TopNavContainer");
		if( !ElTopNavContainer ){
			var ElHookPoint = document.getElementById("sl_a");
			if( ElHookPoint ){
				ElHookPoint = ElHookPoint.parentNode; //.parentNode;
				ElHookPoint.innerHTML = "<div style='float:left;'>" + ElHookPoint.innerHTML + "</div>";
		
				ElTopNavContainer = document.createElement("DIV");
				ElTopNavContainer.id = "TopNavContainer";
				ElTopNavContainer.style.textAlign = "right";
				ElTopNavContainer.style.margin = "auto";
				ElTopNavContainer.style.marginRight = "0px";
				ElTopNavContainer.style.width = "100%";
				ElHookPoint.appendChild( ElTopNavContainer );
				ElTopNavContainer.innerHTML = "&nbsp;";
			}
		}
		if( ElTopNavContainer ){

			if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDReview", false) ){
		
				if( !document.getElementById("GTDReview") ){
	
					ElTopNavContainer.innerHTML = "";

					var daysAgo = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDReview.DaysAgo", "7");
					var timeAgo = GTDGmail_Common.x_days_ago( daysAgo );
					
					var ElGTDReview = document.createElement("DIV");
					ElGTDReview.id = "GTDReview";
					ElGTDReview.setAttribute("title", "View Unfinished Items over " + daysAgo + " Days Old");
					ElGTDReview.style.textAlign = "right";
					ElGTDReview.style.marginTop = "0px;"
					ElGTDReview.style.paddingTop = "0px;"
					ElGTDReview.style.width = "100%";
					
									
					//ElHookPoint.insertBefore( ElGTDReview, ElHookPoint.lastChild );
					ElTopNavContainer.appendChild( ElGTDReview );
				
					var xtraSearchStr = GTDGmail_Common.getCommonSearchTermStr();
				
					var innerHTML = "";
					// Process Each Expected Status (to get the right order)
					var htmlTemplatePresent = "<a href='' class='GTDReview_Link' onclick=\"GTDGmail_SearchBar.doSearch('(label:<!StatusLabelNoSpace!><!SearchLabelInEmailEncodeQuotesNoSpace!>) -label:" + GTDGmail_Common.SharedObj.StandardLabels.Status.Finished.replace(/[ &]/g, "-") + " before:" + timeAgo + "<!XtraSearchStr!>');return false;\"><!StatusLabelNoPrefix!></a>, ";
					//var htmlTemplateNotPresent = "&nbsp;<span class='GTDLabelBox_GTDReview_Link'><!StatusLabel!>&nbsp;[No Label]</span><br/>";
					var htmlTemplateNotPresent = "";
					innerHTML = GTDGmail_Common.renderStandardStatuses_InOrder(htmlTemplatePresent, htmlTemplateNotPresent, true, [ GTDGmail_Common.SharedObj.StandardLabels.Status.Finished ]);
					innerHTML = innerHTML.replace(/, $/, "");
					
					if( innerHTML=="" ){
						ElGTDReview.innerHTML = "&nbsp;";
					}else{
						innerHTML = "&nbsp;&nbsp;&nbsp; <span class='GTDReview_Header'>Review Older: </span>" + innerHTML;
						ElGTDReview.innerHTML = innerHTML;
					}
				}

			}


			/* GTD Search _Search Add to Saved Search
				Test to see if this is a search result.
				If it is, add button to save the search
			*/
			
			if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDSearchQuickSave", false) ){
				if( GTDGmail_Common.SharedObj.Search.ElTextBox && GTDGmail_Common.SharedObj.Search.ElTextBox.value!="" ){
					if( !document.getElementById("QuickAddToGTDSearch") ){
						if( !GTDGmail_SearchBar.isSearchStrSaved( GTDGmail_Common.SharedObj.Search.ElTextBox.value ) ){
							var ElButt = document.getElementById("ac_sp");
							if( ElButt ){
								ElButt = ElButt.parentNode;
								var searchDisplay = ElButt.innerHTML;
								// Remove tags:
								searchDisplay = searchDisplay.replace(/\<([^>]+)\>/g, "");
								if( searchDisplay.indexOf( GTDGmail_Common.SharedObj.Search.ElTextBox.value )!=-1 ){
									
									// It is a search result
									//ElTopNavContainer.innerHTML = "<span id='QuickAddToGTDSearch' style='width:100%;text-align:right;margin:auto;margin-right:0px;margin-bottom:0;padding-bottom:0;'>Save to GTD Saved Searches</span><br/>" + ElTopNavContainer.innerHTML;
									if( ElTopNavContainer.innerHTML!="&nbsp;" ){
										// Line Break
										ElTopNavContainer.innerHTML = "<br/>" + ElTopNavContainer.innerHTML;
									}
									ElTopNavContainer.innerHTML = "<input type='submit' id='QuickAddToGTDSearch' title=\"Add this search['" + GTDGmail_Common.SharedObj.Search.ElTextBox.value + "'] to the list of saved searches.\" value='Save to GTD Saved Searches' style='height:19px;font-size:8pt;margin:auto;margin-right:0px;' onclick='GTDGmail_SearchBar.QuickAddSearch();' />" + ElTopNavContainer.innerHTML;
								}
							}
						}
					}
				}
			}

			//alert(ElTopNavContainer.innerHTML);

		}




				
			/*
			if( !document.getElementById("GTDReview_nb") ){
				
			
				// Get Insert Point:
				var ElHookPoint = document.getElementById("nb_1");	// Try the Invite Friend box
				if( !ElHookPoint ){
					// Just add it to the end of the Navbox
					ElHookPoint = document.getElementById("nav");
					ElHookPoint = ElHookPoint.lastChild;
				}
				
				
				// Create the GTD Review:
				var ElNavBox_GTDReview = this.createNavBox("GTDReview", "GTD Review");
				
				// Insert into page:
				ElHookPoint.parentNode.insertBefore(ElNavBox_GTDReview, ElHookPoint);
				
				// Add Content:
				var ElContent_GTDReview = document.getElementById("GTDReview_Content");

				var innerHTML = "";
				innerHTML += "<span class='GTDLabelBox_GTDReview_Text'>Items Over 1 Week Old:</span><br/>";

				// Process Each Expected Status (to get the right order)
				var htmlTemplatePresent = "&nbsp;<a href='' class='GTDLabelBox_GTDReview_Link' onclick=\"GTDGmail_SearchBar.doSearch('(label:<!StatusLabelNoSpace!>) -label:" + GTDGmail_Common.SharedObj.StandardLabels.Status.Finished.replace(/[ &]/g, "-") + " before:" + GTDGmail_Common.one_week_ago() + "');return false;\"><!StatusLabel!></a><br/>";
				var htmlTemplateNotPresent = "&nbsp;<span class='GTDLabelBox_GTDReview_Link'><!StatusLabel!>&nbsp;[No Label]</span><br/>";
				innerHTML += GTDGmail_Common.renderStandardStatuses_InOrder(htmlTemplatePresent, htmlTemplateNotPresent, true, null);

				
				ElContent_GTDReview.innerHTML = innerHTML;
			}
			*/
		



		/* =====
			GTD About
		==== */
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDAbout", false) ){
			if( !document.getElementById("GTDAbout_nb") ){
				// Get Insert Point:
				// Get the Hook Point (after labels)
				var ElHookPoint = document.getElementById("nb_0");
				ElHookPoint = ElHookPoint.nextSibling;
				
				/*
				var ElHookPoint = document.getElementById("nb_1");	// Try the Invite Friend box
				if( !ElHookPoint ){
					// Just add it to the end of the Navbox
					ElHookPoint = document.getElementById("nav");
					ElHookPoint = ElHookPoint.lastChild;
				}
				*/
				
				
				// Create the GTD About:
				var ElNavBox_GTDAbout = this.createNavBox("GTDAbout", "GTD About");
				
				// Insert into page:
				ElHookPoint.parentNode.insertBefore(ElNavBox_GTDAbout, ElHookPoint);
				
				// Add Content:
				var ElContent_GTDReview = document.getElementById("GTDAbout_Content");
				
				var innerHTML = "";
				innerHTML += "&nbsp;<a href='http://www.gtdgmail.com/gtd/gtdhelp/' class='GTDLabelBox_GTDAbout_Link' target='_blank'>GTD Help</a><br/>";
				innerHTML += "&nbsp;<a href='http://www.gtdgmail.com/gtd/tips_and_tricks/' class='GTDLabelBox_GTDAbout_Link' target='_blank'>GTD Tips & Tricks</a><br/>";
				innerHTML += "&nbsp;<a href='http://www.gtdgmail.com/help/gtdgmail_help/' class='GTDLabelBox_GTDAbout_Link' target='_blank'>GTDGmail Help</a><br/>";
				//innerHTML += "&nbsp;<a href='http://www.gtdgmail.com/about/' class='GTDLabelBox_GTDAbout_Link' target='_blank' style='0.9em'>About GTD Gmail</a><br/>";
				//innerHTML += "<iframe src='http://www.gtdgmail.com/directaccess/inline_news_about/' style='margin-top:3px;width:125px;height:15px;border:0;scroll:none;'></iframe><br/>";
				innerHTML += "&nbsp;<a href='http://www.gtdgmail.com/blog/' class='GTDLabelBox_GTDAbout_Link' target='_blank' style='0.9em'>Our Blog</a><br/>";
				innerHTML += "<br/><center style='font-size:0.55em;color:#888888'>We are not endorsed by Google</center>";

				ElContent_GTDReview.innerHTML = innerHTML;
			}
		}


		
	},
	/*
	addGTDNavBoxes_GetHtml_GTDReviewSearchLink: function(typeStr){
		/*
			Create a HTML link for the GTD Review box
			Use the 'typeStr' (e.g. Project, Rerefence) to retrieve the link name and build the search query (out of labels)
		/
				
		// Process the labels for this Type:
		var searchStr = "";
		var LabelsArray = GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray;
		for( var i = 0; i < LabelsArray.length; i++ ){
			if( searchStr!="" ){
				searchStr += " OR ";
			}
			searchStr += "label:" + LabelsArray[i].replace(/[ &]/g, "-");
		}
		if( searchStr!="" ){
			// Add date criteria:
			searchStr = "(" + searchStr + ")";
			searchStr += " ";
			searchStr += "before:" + GTDGmail_Common.one_week_ago();
		}
		
		var html = "";
		if( searchStr=="" ){
			html += "&nbsp;<span class='GTDLabelBox_GTDReview_Link'>";
			html += GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].displayName;
			html += "&nbsp;[No Labels]";
			html += "</span>";
		}else{		
			html += "&nbsp;<a href='' class='GTDLabelBox_GTDReview_Link' ";
			html += "onclick=\"GTDGmail_SearchBar.doSearch('" + searchStr + "');return false;\">";
			html += GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].displayName;
			html += "</a>";
		}
		html += "<br/>";
		
		return html;
		
	},
	*/
	addGTDNavBoxes_NoticeBox: function(){
		/* =====
			GTD Notices
				Check for: Project, Reference, Status, Context
				Check for Core Items: T:To Do, R:Reference
				
				Only show if there are any problems.
		==== */
		
		var noticePrefix = "GTDNotice";
		
		// Destroy old one:
		var ElNoticeBoxOld = document.getElementById(noticePrefix + "_nb");
		if( ElNoticeBoxOld ){
			// Remove the old one
			ElNoticeBoxOld.parentNode.removeChild( ElNoticeBoxOld );
		}
		
		// See What is Missing
		var innerHTML = "";
				
		// Check for Project, Reference, Status, Context:
		var CoreTypes = ["Project", "Reference", "Status", "Context"];
		for( var i = 0; i < CoreTypes.length; i++ ){
			//if( CoreTypes[i].toLowerCase()!="context" ){
				// Context is not required
				if( GTDGmail_Common.SharedObj.LabelsObj[CoreTypes[i]].LabelArray.length==0 ){
					// This CoreType does not have any entries
					innerHTML += "<div class='lk cs' id='prf_l' style='font-size:0.65em' title='Click to go to Labels Settings'>Add Labels for " + GTDGmail_Common.SharedObj.LabelTypesObj[CoreTypes[i]].displayName + "</div>";
				}
			//}
		}
		// Check for Status:
		innerHTML += GTDGmail_Common.renderStandardStatuses_InOrder("", "<div class='lk cs' id='prf_l' style='font-size:0.65em' title='Click to go to Labels Settings'>Add Status [<i><!StatusLabel!></i>]</div>", false, null);
		// Check for Core Labels (T:To Do, R:Reference)
		//alert(GTDGmail_Common.SharedObj.StandardLabels.ToDo.toString());
		if( !GTDGmail_Common.testLabelInUse("Reference", GTDGmail_Common.SharedObj.StandardLabels.Reference.Reference) ){
			innerHTML += "<div class='lk cs' id='prf_l' style='font-size:0.65em' title='Click to go to Labels Settings'>Add Label [<i>" + GTDGmail_Common.SharedObj.StandardLabels.Reference.Reference + "</i>]</div>";
		}	
		if( !GTDGmail_Common.testLabelInUse("Reference", GTDGmail_Common.SharedObj.StandardLabels.Reference.ProjectHome) ){
			innerHTML += "<div class='lk cs' id='prf_l' style='font-size:0.65em' title='Click to go to Labels Settings' >Add Label [<i>" + GTDGmail_Common.SharedObj.StandardLabels.Reference.ProjectHome + "</i>]</div>";
		}	
		if( innerHTML!="" ){
			// Give it a heading:
			var introText = "<div style='font-size:0.55em;margin-left:2px;color:#666666;'>";
			introText += "Please setup GTD Labels<br/>and Filters before you start<br/>using GTDGmail.";
			introText += "</div><br/>";
			innerHTML = introText + "<span class='GTDLabelBox_GTDNotice_Heading'>Setup Tasks:</span>" + innerHTML;
		}
		
		
		
		if( innerHTML!="" ){
			// Add a bit about Filters
			innerHTML += "<br/><div id='' style='font-size:0.55em;margin-left:2px;'>Add Address Filters for Task</div>";
			innerHTML += "<div id='' style='font-size:0.55em;margin-left:20px;'>+ Reference</div>";
			
			// Create a link to the website
			innerHTML += "<br/><span class='GTDLabelBox_GTDNotice_Heading'>Useful Links</span>";
			innerHTML += "<div id='' style='font-size:0.55em;margin-left:2px;'><a style='color:blue;' href='http://www.gtdgmail.com/help/installguide/' target='_blank'>Installation Guide</a></div>";
			
			innerHTML += "<br/> <div style='font-size:0.55em;margin-left:2px;color:#666666;'> Some things have tooltips to <br/>give you hints - just try <br/>putting your mouse over items. </div> ";
			
			// Add Notes
			innerHTML += "<br/><div style='font-size:0.55em;margin-left:2px;color:#666666;'>This Notice Box will disappear<br/>when Setup is complete.<br/><br/>Tune GTDGmail using <a href='' style='color:blue;' onclick=\"try{document.GtdOverlayGlobals.browser_appcontent.GtdShared.ChromeOnlyExec.openOptions();return false;}catch(e){}\">Options</a>.<br/><br/><a href='' style='color:blue;' onclick=\"try{GTDGmail_NavBar.removeGTDNotice();return false;}catch(e){}\">Remove Installation Box</a>.</div>";

			// Create a Notice Box
			var ElNavBox_GTDNotice = this.createNavBox(noticePrefix, "GTD Installation");
			
			// Get the Hook Point (after labels)
			var ElHookPoint = document.getElementById("nb_0");
			//ElHookPoint = ElHookPoint.nextSibling;
			// Attach Notice Box:
			ElHookPoint.parentNode.insertBefore(ElNavBox_GTDNotice, ElHookPoint);
			
			// Update the Content
			var ElContent_GTDNotice = document.getElementById(noticePrefix + "_Content");
			ElContent_GTDNotice.innerHTML = innerHTML;
			
		}
		
		// Hide us if that's the setting:
		GTDGmail_Common.hideShowHideElements();
		
	},
	removeGTDNotice: function(){
		// Disable GTD Notice
		// Remove the box
		try{
			document.GtdOverlayGlobals.browser_appcontent.GtdShared.ChromeOnlyExec.disableInstallationBox();
			
			var ElInstallBox = document.getElementById("GTDNotice_nb");
			ElInstallBox.parentNode.removeChild(ElInstallBox);
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_NavBar");
		}
	},
	
	
	createNavBox: function(prefix, title){
		/*
			Create a Nav Box element
				Clone the Labels nav box
				Use a TreeWalker over all the elements to update IDs with the prefix
				Remove the existing content
		*/
		try{
			var ElNavBoxLabels = document.getElementById("nb_0");
			
			// Clone Labels:
			var ElNavBoxNew = ElNavBoxLabels.cloneNode(true);
			ElNavBoxNew.id = prefix + "_nb";
			
			var TitleNode = null;
			
			// Replace IDs:
			var elImgToRemove = null;
			var tw = document.createTreeWalker(ElNavBoxNew, ~NodeFilter.SHOW_COMMENT, null, false);
			for(var childNode = tw.firstChild(); childNode!=null; childNode = tw.nextNode()){
				if( childNode.nodeName.toLowerCase()=="td" && childNode.className=="s" ){
					// It's the title:
					//childNode.innerHTML = title + "&nbsp;<a id='GTD_ShowHideLink_" + prefix + "' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='hide' elToShowHide='" + prefix + "_Content' textShow='[Show]' textHide='[Hide]' class='GTDLabelBox_NewBox_ShowHide' >[Hide]</a>";
					TitleNode = childNode;
				}
				if( childNode.id=="nt_0" ){
					// Stop Mouse Over
					childNode.className = "";
					
					// It's next sibling is the Content - rip it out
					if( childNode.nextSibling ){		
						childNode.parentNode.removeChild( childNode.nextSibling );
					}
					// Replace it with a Div holder
					var ElDiv = document.createElement("DIV");
					ElDiv.id = "Content";
					ElDiv.className = "nb";
					ElDiv.style.backgroundColor = "white";
					childNode.parentNode.appendChild( ElDiv );
					
				}
				if( childNode.id && childNode.id!="" ){
					// It has an ID, apply prefix
					childNode.id = prefix + "_" + childNode.id
				}
				if( childNode.src && childNode.src.indexOf(".gif")!=-1 ){
					// Remove img
					elImgToRemove = childNode;
				}
			}
			// Do last to not interrupt the TreeWalker:
			elImgToRemove.parentNode.removeChild(elImgToRemove);
			//TitleNode.innerHTML = "";
			TitleNode.innerHTML = "<a id='GTD_ShowHideLink_" + prefix + "' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='hide' elToShowHide='" + prefix + "_Content' textShow=\"<img src='images/triangle.gif'/>\" textHide=\"<img src='images/opentriangle.gif'/>\" class='GTDLabelBox_NewBox_ShowHide' ><img src='images/opentriangle.gif'/></a>&nbsp;" + title;
			
			
			return ElNavBoxNew;
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_NavBar");
		}
		return null;
		
	},
}
