/*

	Gtd Gmail
	(c) 2005 2006 Andy Mitchell [andy@gtdgmail.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@gtdgmail.com]'
	It is also a requirement to place the url, http://www.gtdgmail.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in new projects.

*/




/* ===============================================
	GENERAL
================================================*/



var GtdUtilGeneral = {

	testFire: function(){
		alert("it works");
	},
	
	prepQueryUrl: function(queryUrl, queryStr){
		queryStr = queryStr.replace(/\&/g, "%26");
	
		queryUrl = queryUrl.replace(/\[QUERY\]/g, queryStr);
		queryUrl = queryUrl.replace(/\s/g, "%20");
		queryUrl = queryUrl.replace(/\'/g, "%27");
		return queryUrl;
	},

	extractDomainFromUrl: function(strUrl){
		if(!strUrl){
			return "";
		}
		if(strUrl==""){
			return "";
		}
		
		var strDomain = strUrl.match(/(\w*)((:\/\/)?)([^\s\/\\]+)/gi);
		if(strDomain){
			return strDomain[0];
		}else{
			return "";
		}
	},

	extractDomainNameFromUrl: function(strUrl){
		if(!strUrl){
			return "";
		}
		if(strUrl==""){
			return "";
		}
		
		// Trim to full domain:
		strUrl = this.extractDomainFromUrl(strUrl);
		// Remove http:// prefix:
		strUrl = strUrl.replace(/([\w]+):\/\//i, "");
				
		// Trim the tail:
		strUrl = strUrl.replace(/\.([\w]{2,3})$/gi, "");
		strUrl = strUrl.replace(/\.([\w]{2,3})$/gi, "");
		
		
		// And if there's a front bit:
		strUrl = strUrl.replace(/^(\w+)\./gi, "");
				
		return strUrl;
	},
	
	removeHttpPrefixFromUrl: function(strUrl){
		if(!strUrl){
			return "";
		}
		if(strUrl==""){
			return "";
		}
		return strUrl.replace(/(\w*):\/\//gi, "");
	},


	sortArrayByLength: function(inputArray){
		for(var i = 0; i < inputArray.length; i++){
			inputArray[i] = GtdUtilGeneral.prefixZeros(inputArray[i].length, 3) + "" + inputArray[i];
		}

		inputArray.sort();
		inputArray.reverse();

		for(var i = 0; i < inputArray.length; i++){
			inputArray[i] = inputArray[i].sugtdtr(inputArray[i].indexOf("")+1);
		}

		return inputArray;
	},

	prefixZeros: function(theString, desiredLength){
		// Pad the string with zeros, until the desired length is met
		theString = theString + "_";
		while(theString.length <= desiredLength){
			theString = "0" + theString;
		}

		return theString.sugtdtr(0, theString.length - 1);
	},




	extractQueryFromUrl: function(SeObjects, seName, strUrl){
		/*
			Given search engine name, use the patternQuery to extract the query string.
			If found, return query string.
			Else nothing.
		*/

		if(!SeObjects[seName] || !SeObjects[seName].regexPattern_Query){
			return "";
		}

		

		var queryArray = SeObjects[seName].regexPattern_Query.exec( strUrl );
		if(!queryArray || queryArray.length < 1 || queryArray[1]==null){
			return "";
		}



		return this.convertHexUrlToCharUrl( queryArray[1] );
	},

	parseQueryIntoWords: function(queryStr, includePhrases, sortWordsByLength){

		// Remove spaces from the query:
		queryStr = queryStr.replace(/[+]/g, " ");

		var wordArray = new Array();
		if(includePhrases){
			//Pull out "" phrases
			var tmpPhraseArray = queryStr.match(/\"([^"]*)\"/g);
			
			// Trim quotes:
			var j = 0;
			if(tmpPhraseArray!=null){
				for(var i = 0; i < tmpPhraseArray.length; i++){
					if(tmpPhraseArray[i].length>2){
						wordArray[j] = tmpPhraseArray[i].sugtdtr(1, tmpPhraseArray[i].length - 2);
						j++;
					}
				}
			}
		}else{
			// Just remove quotes:
			queryStr = queryStr.replace("\"", "");
		}


		//Remove phrases, AND, OR:
		queryStr = queryStr.replace(/((\"([^"]*)\")|(AND)|(OR))([ ]*)/g, "");


		//Remove <char>:<\w> instructions (like related:www.blah.com)
		queryStr = queryStr.replace(/([a-zA-Z]+)\:([^\+\s]+)/g, "$2")

		wordArray = wordArray.concat( queryStr.split(/[\s]+/) );

		if(sortWordsByLength){
			// sort by length, so biggest words get picked up first:
			wordArray = GtdUtilGeneral.sortArrayByLength(wordArray);
		}

		return wordArray;

	},
	
	copyArray: function(oldArray){
		//var newArray = new Array();
		
		//for( var i = 0; i < oldArray.length; i++){
		//	newArray[i] = oldArray[i];
		//}
		
		if(oldArray.length==0){
			return new Array();
		}
		
		var arrayStr = oldArray.join(",");
		return arrayStr.split(",");
		
	},
	
	firstLetterUpperCase: function(oldStr){
		/*
			Take the first letter, and make it upper case (return whole string)
		*/
		
		if(oldStr==""){
			return "";
		}
		if(oldStr.length==1){
			return oldStr.toUpperCase();
		}
		
		var newStr = oldStr.sugtdtr(0, 1).toUpperCase();
		newStr += oldStr.sugtdtr(1);
		
		return newStr;
	},
	
	convertHexUrlToCharUrl: function(hexedLink){
		/*
			Take a link with items such as %2F in it.
			For each % symbol, remove it and the sugtdequent 2 characters.
				Convert the hex to a number.
				Convert that number to a character.
				Reinsert it.
		*/

		var newLink = "";
		while( hexedLink.indexOf("%")!=-1 ){
			var splitUrlArray = hexedLink.split("%");
			newLink += splitUrlArray[0];
			
			if(splitUrlArray.length==1){
				// No %
				break;
			}
			
			
			// Extract two hex characters
			var hexVal = splitUrlArray[1].sugtdtr(0,2);
			if(/[a-fA-F0-9]{2}/.test(hexVal)){
				newLink += String.fromCharCode("0x" + hexVal);
				//alert("splitUrlArray[1]: " + splitUrlArray[1]);
				hexedLink = splitUrlArray[1].sugtdtr(2);
				//alert("hexLink: " + hexedLink);
			}else{
				//Put the string back together
				newLink += "%"
				hexedLink = splitUrlArray[1];
			}

			if( splitUrlArray.length > 1 ){
				// More parts of the array to retain:
				for(var i = 2;  i < splitUrlArray.length; i++)
				{
					hexedLink += "%" + splitUrlArray[i];
				}
			}

			if( hexedLink.indexOf("%")==-1 ){
				// No more %, must reattach remaining string part:
				newLink += hexedLink;
			}
		}
		if(newLink==""){
			newLink = hexedLink;
		}

		return newLink;
	},

	encodeUrl: function(charUrl){
		/*
			Convert ' ', & to their encoded equivelents
		*/

		var hexUrl = charUrl.replace(/\s/g, "%20");
		var hexUrl = hexUrl.replace("&", "%26");

		return hexUrl;
	},
	
	getPrettyKeyConfig: function(optionSet, gtdOptions){
		/*
			Return the key config in a nice format, for the option group with the ID optionSet.
		*/
		
		var prettyKeys = "";
		try{
			var rawKey1 = gtdOptions.getOption("char", optionSet + ".key1", "");
			var rawKey2 = gtdOptions.getOption("char", optionSet + ".key2", "");
			var prettyKey3 = gtdOptions.getOption("char", optionSet + ".key3", "");
			
			var prettyKey1 = "";
			var prettyKey2 = "";
			
			if( rawKey1!="!" ){
				if( rawKey1=="accel" ){
					if( navigator.platform.indexOf("Win32")!=-1 ){
						prettyKey1 = "Ctrl";
					}else if( navigator.platform.indexOf("Mac")!=-1 ){
						prettyKey1 = "Accel";
					}else if( navigator.platform.indexOf("Linux")!=-1 ){
						prettyKey1 = "Accel";
					}
				}else{
					prettyKey1 = GtdUtilGeneral.firstLetterUpperCase(rawKey1);
				}
			}
			
			if( rawKey2!="!"){
				if( rawKey2=="accel" ){
					if( navigator.platform.indexOf("Win32")!=-1 ){
						prettyKey2 = "Ctrl";
					}else if( navigator.platform.indexOf("Mac")!=-1 ){
						prettyKey2 = "Accel";
					}else if( navigator.platform.indexOf("Linux")!=-1 ){
						prettyKey2 = "Accel";
					}
				}else{
					prettyKey2 = GtdUtilGeneral.firstLetterUpperCase(rawKey2);
				}
			}
			
			prettyKeys = prettyKey1;
			if(prettyKey2!=""){
				if(prettyKeys!=""){
					prettyKeys += "+";
				}
				prettyKeys += prettyKey2;
			}
			if(prettyKey3!=""){
				if(prettyKeys!=""){
					prettyKeys += "+";
				}
				prettyKeys += prettyKey3;
			}
		}catch(e){
			prettyKeys = "";
		}
		
		return prettyKeys;
	},


	createElement: function(elName){
		return document.createElementNS('http://www.w3.org/1999/xhtml', elName);
	},
	
	simulateLinkClick: function(linkId){
		try{
			var gtdClickEl = document.getElementById(linkId);
			var clickEvent = document.createEvent('MouseEvents');
			clickEvent.initMouseEvent('click', true, true, document.defaultView, 1, 0, 0, 0, 0, false, false, false, false, 0, null); 
			gtdClickEl.dispatchEvent( clickEvent );
		}catch(e){
			//alert("FAIL HERE");
		}
	},

	injectCSS: function(cssName){
		/*
		Inject a chrome link to the relevant CSS file
		*/
		
		
		var docHead = document.getElementsByTagName("head")[0];
		docHead.innerHTML += "<link rel=STYLESHEET href='" + cssName + "' type='text/css' />";
		
		/*		
		
		var elStyle = document.createElement("LINK");
		if( !elStyle ) return;
		elStyle.setAttribute("rel", "STYLESHEET");
		elStyle.setAttribute("href", cssName);
		elStyle.setAttribute("type", "text/css");
		docHead.appendChild(elStyle);
		*/
	    
	},
	
	keywordEventHandler_CropToKeyword_AddHandler: function(elKeyword, elCropWords){
		/*
			Attach onmouseup to the keyword box; and attach the name of the CropWords element
		*/
		
		try{
			var oldMouseUp = elKeyword.getAttribute("onclick");
			if(!oldMouseUp){
				oldMouseUp = "";
			}
			
			elKeyword.setAttribute("onclick", oldMouseUp + "GtdUtilGeneral.keywordEventHandler_CropToKeyword_MouseUp(event)");
			elKeyword.setAttribute("elCropWordsId", elCropWords.id);
			
			var oldOnClick = elCropWords.getAttribute("onclick");
			if(!oldOnClick){
				oldOnClick = "";
			}
			elCropWords.setAttribute("onclick", oldOnClick + "GtdUtilGeneral.keywordEventHandler_CropToKeyword_Click(event)");
			elCropWords.setAttribute("elKeywordId", elKeyword.id);
		}catch(e){
			//alert(e.toString());
		}
	},
	keywordEventHandler_CropToKeyword_MouseUp: function(event){
		/*
			Retrieve the CropWords element
			See if CropWords element should be visible or not
		*/
		
		
		
		try{
			var elKeyword = event.target;
			
			var cropWordsId = elKeyword.getAttribute("elCropWordsId");
			var elCropWords = document.getElementById(cropWordsId);
			if(!elCropWords) return;
			
			
			if( elKeyword.selectionStart!=elKeyword.selectionEnd ){
				/*
					We have a selection.
					Show the option to 'Crop to Selected Text'
				*/
				
				elCropWords.style.visibility = "visible";
			}else{
				elCropWords.style.visibility = "hidden";
			}
		}catch(e){
			//alert(e.toString());
		}
		
	},
	keywordEventHandler_CropToKeyword_Click: function(event){
		/*
			Actually crop the selected text, then hide the crop words
		*/
		
		if(event){
			event.stopPropagation();
			event.preventDefault();
		}
		
		try{
			var elCropWords = event.target;
			
			var keywordId = elCropWords.getAttribute("elKeywordId");
			var elKeyword = document.getElementById(keywordId);
			if(!elKeyword) return;
						
			elKeyword.value = elKeyword.value.sugtdtring(elKeyword.selectionStart, elKeyword.selectionEnd);
			
			elCropWords.style.visibility = "hidden";
		}catch(e){
			//alert(e.toString());
		}
	}
	
	
	
	
	
}



var GtdUtilGeneral_Local = {
	/*
		General functions utilised only within pages (not overlays).
	*/
	
	testFire: function(){
		alert("it works");
	},

	getDomDoc_Overlay: function(){
		/*
			Return the DOM document of Gtd Gmail's main page overlay.
		*/
		
		return document.gtdGmail_BrowserPageOverlay;
	},
	
	getGlobals_Overlay: function(){
		/*
			Return the the GtdGlobals object.
			Shorthand for the above.
		*/
		
		//return document.gtdGmail_BrowserPageOverlay.GtdOverlayGlobals;	//SECURITY PERMISSIONS ARE JOYLESS
		return document.GtdOverlayGlobals;
	},
	

	includeScriptaculous_DEPRECIATED: function(){
		/*
			If not already in the local DOM, include the JS
		*/
		
		try{
			var pageDocHead = document.getElementsByTagName("head")[0];
			
			
			if( pageDocHead.innerHTML.indexOf("effects.js")!=-1 ){
				return;
			}
			
			// include it
			
			var elScript;
			try{
				elScript = document.createElement("SCRIPT");
			}catch(e){
				elScript = GtdUtilGeneral.createElement("SCRIPT");
			}
			elScript.setAttribute("type", 'text/javascript');
			elScript.setAttribute("src", "chrome://gtdgmail/content/scriptaculous/prototype.js");
			pageDocHead.appendChild(elScript);
				
			var elScript;
			try{
				elScript = document.createElement("SCRIPT");
			}catch(e){
				elScript = GtdUtilGeneral.createElement("SCRIPT");
			}
			elScript.setAttribute("type", 'text/javascript');
			elScript.setAttribute("src", "chrome://gtdgmail/content/scriptaculous/effects.js");
			pageDocHead.appendChild(elScript);
			
		}catch(e){
			//alert(e.toString());
		}
			
	}


}
//GtdUtilGeneral_Local.getGlobals_Overlay().