/*

	Gtd Gmail
	(c) 2005 2006 Andy Mitchell [andy@gtdgmail.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@gtdgmail.com]'
	It is also a requirement to place the url, http://www.gtdgmail.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in new projects.

*/





//GtdUtilGeneral_Server.openUrlInNewTab();


var GtdUtilGeneral_Server = {

	testFire: function(){
		alert("works");
	},

	init_Browser_SharedObjects: function(appcontent, bool_forceNewCreate, GtdOptions){
		/*
			Do test to see if shared BS objects (such as SearchEngines, BrowserPagesParentChild) are in shared memory.
			
			If not, load them.
		*/

		if( !appcontent ){
			//alert("fail");
			return;
		}

		// Holding Object:
		if( !appcontent.GtdShared ){
			appcontent.GtdShared = new Object();
		}
		
		
		try{
			// Specialised Cross Pollination
			if( GtdOptions.getOption("bool", "CrossPollination.Specialised.Enabled", false)==true ){
				if( !appcontent.GtdShared.CpSpecialisations || bool_forceNewCreate ){
					appcontent.GtdShared.CpSpecialisations = Gtd_getCrossPollinationSpecialisedObject(GtdOptions);
				}
			}
		}catch(e){
			//alert(e.toString());
		}
			
					
		
	},
	
	attach_StringBundle: function( attachElement, newObjName, bundleNameAndPath ){
	
		
		try{
			var elSB = document.createElement("stringbundle");
			elSB.id = newObjName;
			elSB.setAttribute("src", bundleNameAndPath );
			document.documentElement.appendChild(elSB);
			attachElement[newObjName] = document.getElementById(newObjName);	
		}catch(e){
			//alert(e.toString());
		}
	
	},
	
	write_Error: function(GtdOptions, errorStr){
		//alert("General: " + errorStr);
		try{
			var origErrors = GtdOptions.getOption('char', 'BS.CaughtErrors', '');
			origErrors = errorStr + "\n\n" + origErrors;
			if(origErrors.length>4096){
				origErrors = origErrors.sugtdtr(0, 4095);
			}
			GtdOptions.setOption('char', 'BS.CaughtErrors', origErrors);
		}catch(e){}	
	},


	openUrlInNewTab: function(url){
		windowMediatorIID = Components.interfaces.nsIWindowMediator;
		windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(windowMediatorIID);
		topWin = windowMediator.getMostRecentWindow("navigator:browser");
		var tab = topWin.getBrowser().addTab(url);
		topWin.getBrowser().selectedTab = tab;
	},
	
	getSelectedTabBrowser: function(){
		/*
			Return the TAB of the selected tab
		*/
		
		var windowMediatorIID = Components.interfaces.nsIWindowMediator;
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(windowMediatorIID);
		var topWin = windowMediator.getMostRecentWindow("navigator:browser");
		
		var currentTab = topWin.getBrowser().selectedTab;		
		return topWin.getBrowser().getBrowserForTab(currentTab);
	},





















	execute_InlineScript_PageDom: function(pageDoc, inlineScript){
		/*
			Temporarily attach a SCRIPT element to the page's DOM.
			This will cause it to be executed; then it can be removed.
		*/
		
		//GtdUtilGeneral_Server.write_Error('Local:\\n' + e.toString())
		inlineScript = "try{\n" + inlineScript + "\n}catch(e){   }";
		
		
		
		var elScript = pageDoc.createElement("SCRIPT");
		elScript.setAttribute("id", "tempInlineScript");
		elScript.appendChild( pageDoc.createTextNode(inlineScript) );
		pageDoc.body.appendChild(elScript);
		pageDoc.body.removeChild(elScript);
		
	},

	attach_JavascriptSource_PageDom: function(pageDoc, pageDocHead, jsUri){
		/*
			Attach a reference to the given javascript to the page's DOM
		*/
	
		/*
		if( pageDocHead.innerHTML.indexOf("src=\"" + jsUri + "\"")!=-1 ){
			// Already injected
			return;
		}

		*/
		try{
			var elScript = pageDoc.createElement("SCRIPT");
			elScript.setAttribute("type", 'text/javascript');

			/*
			elScript.setAttribute("src", jsUri);
			*/

			var stxt = this.getSCon(jsUri);
			elScript.appendChild(pageDoc.createTextNode(stxt));

			pageDocHead.appendChild(elScript);
		}catch(e){
			//alert(e.toString());
		}
	},
	getSCon: function(aurl) //read script from file and returns it as string
	{
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);
		var channel = ioService.newChannel(aurl, null, null);
		var input = channel.open();
		scriptableStream.init(input);
		var str = scriptableStream.read(input.available());
		scriptableStream.close();
		input.close();
		return str;
	},

	insert_JavascriptCode_PageDom: function(pageDoc, pageDocHead, jsCode){
		/*
			Insert code permanently into the page DOM
		*/
		
		
		var elScript = pageDoc.createElement("SCRIPT");
		elScript.setAttribute("type", 'text/javascript');
		elScript.appendChild( pageDoc.createTextNode(jsCode) );
		pageDocHead.appendChild(elScript);
	},

	attach_JavascriptEventHandler_PageDom: function(pageDoc, pageDocHead, eventType, eventFunction, eventCode){
		/*
			Create a function within in the page DOM
			Execute an inline script, to addEventListener to the new function.
		*/
		
		//var pageDoc = document.GtdOverlayGlobals.refPageDomDoc;
				
		this.insert_JavascriptCode_PageDom(pageDoc, pageDocHead, eventCode);
		
		var inlineScript = "";
		if(eventType=="unload"){
			// Modify body tag:
			inlineScript = "document.body.setAttribute('onunload', '" + eventFunction + "();');";
		}else{
			// Use event handler:
			inlineScript = "document.body.addEventListener('" + eventType + "', " + eventFunction + ", false);"
		}
		this.execute_InlineScript_PageDom(pageDoc, inlineScript );
	}



}