/*

	Gtd Gmail
	(c) 2005 2006 Andy Mitchell [andy@gtdgmail.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@gtdgmail.com]'
	It is also a requirement to place the url, http://www.gtdgmail.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in new projects.

*/


































/* ===============================================
	INNER SEARCH - ALTERNATE ENGINES
================================================*/

var AltSearchEngines = {

	strLocaleEntities: GtdUtilGeneral_Local.getGlobals_Overlay().browser_appcontent.GtdShared.OverlayStringBundle,
	bool_UseEffects: false,
	

	getHTML: function(callBackPrefix, bool_RemoveCommercial){
		/*
			Gets the DIV for alternate search engines, that heads up the page.
			Then includes the InnerSearchBox
		*/
		
		var isStr = "";

		isStr += "<table width='100%' border=0 cellspacing=0 cellpadding=0 NoGtdCrossPolli=true><tr><td>";
		isStr += "	<div style='font-size:small;'>";
		isStr += "		<div style='float:left;'>";
		isStr += "			<div id=AltSearchEngines class=InnerSearchAltEngines></div>";
		isStr += "		</div>";
		if(bool_RemoveCommercial==true){
			isStr += "		<div class=AltSearchEngines_RemoveCommercial style='float:right;' >";
			isStr += "			<a href='' title='" + this.strLocaleEntities.getString("InnerSearch.AltEngines.RemoveCommercial.Tooltip") + "' onClick='" + callBackPrefix + ".removeCommercialResults(event)'>" + this.strLocaleEntities.getString("InnerSearch.AltEngines.RemoveCommercial") + "</a>";
			isStr += "		</div>";
		}
		isStr += "	</div>";
		isStr += "</td></tr></table>";
		isStr += "	<div>";
		isStr += "		<a id=AltSearchEngines_MoreTag href='' class=myLink onClick=AltSearchEngines.toggleMoreEngines(event) style='color:#00c;display:none'>" + this.strLocaleEntities.getString("InnerSearch.AltEngines.MoreLess.More") + "&#187;</a>";
		isStr += "		<div id=AltSearchEngines_More class=AltSearchEngines_List_More style='display:none'></div>";
		isStr += "	</div>";
		isStr += "	<div id=InnerSearch_Result_Container_Main class=AltSearchEngines_InnerSearch_Container style='display:none;' align='center'>";
		isStr +=			InnerSearchBox.getHTML(callBackPrefix, "Main", false);
		isStr += "	</div>";
		



		return isStr;
	},


	loadPrimarySecondary: function(callBackPrefix, callerSEI_SeName, queryStr, xtraKeywords, bool_PrioritiseOnKeyword){
		/*
			Load the search engines for the InnerSearchBox.
			
			If the calling-SEI-engine is specialised in some way:
				Consider all primary/secondary search engines
				If search engine has matching specialisation
					Make it primary
				otherwise, make it secondary
			If SEI not specialised,
				If search engine is primary, put it in the primary section
				Otherwise, put it in the secondary string
			
			In any case,
				If keyword in search engine matches query; put it into special engines
					and do not put into primary/secondary
		*/
		
		/*
			Ordering the 'More' tag
			
			'More' items are split into their relevant specialisations.
			
			- Create SeMore object, with properties (pointing to arrays) that match the known specialisations (from RDF)
			- When processing search engines, add se to an SeMore array that matches it's specialisation
			- Construct More div out of the SeMore object
		*/
		
				
		// Retrieve the search engines		
		var SearchEngines = GtdUtilGeneral_Local.getGlobals_Overlay().browser_appcontent.GtdShared.SearchEngines;
		
		var callerSeObject = 0;
		if(SearchEngines.SeObjects[callerSEI_SeName]){
			var callerSeObject = SearchEngines.SeObjects[callerSEI_SeName];
		}
		
		
		
	
		// Turn the query into an array of words:
		var queryWordsArray = GtdUtilGeneral.parseQueryIntoWords(queryStr, false, false);
		// Make them lower case for efficiency
		for(var i = 0; i < queryWordsArray.length; i++){
			queryWordsArray[i] = queryWordsArray[i].toLowerCase();
		}
		
		
		var bool_SEI_Specialised = false;
		if(callerSeObject && callerSeObject.specialisation && callerSeObject.specialisation!="" && callerSeObject.specialisation!="*" ){
				bool_SEI_Specialised = true;
		}


		// Prepare the 'More' object:
		var SeMore = new Object();
		for(var i = 0; i < SearchEngines.SeSpecialisationsArray.length; i++){
			var specialisationName = SearchEngines.SeSpecialisationsArray[i];
			SeMore[specialisationName] = new Array();
		}
		
		
		// Iterate through available search engines:
		var strContext = "";
		var strPrimary = "";


		for(var i = 0; i < SearchEngines.SeNamesArray.length; i++){
			var SeObject = SearchEngines.SeObjects[ SearchEngines.SeNamesArray[i] ];
			// Only those with a true display name:
			if(SeObject.displayName ){
				if( SeObject.name==callerSEI_SeName || (callerSeObject && callerSeObject.parentName && SeObject.name==callerSeObject.parentName) ){
					// This search engine is us, make it a 'more'
					this.addSe_ToSeMoreObject(SeMore, SeObject);
				}else{
					if( bool_PrioritiseOnKeyword==true && SeObject.keywords && SeObject.keywords!="" && AltSearchEngines.keyword_in_query(SeObject, queryStr + xtraKeywords) ){
						// Related to this query, make it a Context Engine
						if( bool_SEI_Specialised==false || (SeObject.specialisation && ( SeObject.specialisation=="*" || (callerSeObject && SeObject.specialisation==callerSeObject.specialisation) ) ) ){
							// It's not specialised, or it meets our specialisation
							strContext = AltSearchEngines.createStr_Context(strContext, SeObject, callBackPrefix, queryStr);
						}
					}else if( (SeObject.displayAltEngine && SeObject.displayAltEngine!="") ){
						if(bool_SEI_Specialised==true){
								if(SeObject.specialisation && ( SeObject.specialisation=="*" || (callerSeObject && SeObject.specialisation==callerSeObject.specialisation) ) ){
									// Make it primary
									strPrimary = AltSearchEngines.createStr_Primary(strPrimary, SeObject, callBackPrefix, queryStr);
								}else{
									this.addSe_ToSeMoreObject(SeMore, SeObject);
								}
						}else{
							// All isPrimary engines made primary; otherwise secondary
							if(SeObject.displayAltEngine_Primary && SeObject.displayAltEngine_Primary!=""){
								// Make it primary
								strPrimary = AltSearchEngines.createStr_Primary(strPrimary, SeObject, callBackPrefix, queryStr);
							}else{
								// Make it secondary
								this.addSe_ToSeMoreObject(SeMore, SeObject);
							}
						}
					}
				}
			}
		}

		

 		var divAltEngines = document.getElementById("AltSearchEngines");
 		if(!divAltEngines)	return;
		var divAltEnginesMore = document.getElementById("AltSearchEngines_More");
		divAltEngines.innerHTML = "";
		if(strContext!=""){
			if(strContext.lastIndexOf("-&nbsp;")!=-1){
				strContext = strContext.sugtdtr(0, strContext.lastIndexOf("-") );
			}
			divAltEngines.innerHTML = "<i>" + this.strLocaleEntities.getString("InnerSearch.AltEngines.TrySearch.RelevantEngines") + "&nbsp;" + strContext + "</i><br/>";
		}
		if(strPrimary!=""){
			if(strPrimary.lastIndexOf("-&nbsp;")!=-1){
				strPrimary = strPrimary.sugtdtr(0, strPrimary.lastIndexOf("-") );
			}
			divAltEngines.innerHTML = divAltEngines.innerHTML + "<span title='" + this.strLocaleEntities.getString("InnerSearch.AltEngines.TrySearch.PrimaryEngines.Tooltip") + "'>" + this.strLocaleEntities.getString("InnerSearch.AltEngines.TrySearch.PrimaryEngines") + " &nbsp;</span>" + strPrimary;
		}
		
		// Get the first link to focus upon it:
		var elLinks = divAltEngines.getElementsByTagName("A");
		if(elLinks.length > 0){
			elLinks[0].focus();
		}
		
		
		
		// Create strMore out of the SeMore object
		var strMore = "";
		strMore += "<table border=0 cellspacing=0 cellpadding=0 style='width:100%'>";
		strMore += "<tr>";
		for(specialisation in SeMore){
			// Get the title:
			if(specialisation!="extend"){		// ALERT DEBUG: NEEDS ATTENTION. WHY? JUST WHY? WHERE THE HELL DOES EXTEND COME FROM?
				strMore += "<td id='header" + specialisation + "'>";
					strMore += specialisation;
				strMore += "</td>";
			}
		}
		strMore += "</tr><tr>";
		for(specialisation in SeMore){			
			// Get all the Search Engines in this Specialisation:
			var seName = "";
			
			strMore += "<td valign=top>";
			strMore += "<ul ";
				// Add mouse over event to the list, so its header does something exciting:
				strMore += "onmouseover=\"document.getElementById('header" + specialisation + "').style.color='#000000';\" ";
				strMore += "onmouseout=\"document.getElementById('header" + specialisation + "').style.color='';\" ";
			strMore += ">";
			for(var i = 0; i < SeMore[specialisation].length; i++){
				seName = SeMore[specialisation][i];
				strMore = this.createStr_More(strMore, SearchEngines.SeObjects[seName], callBackPrefix, queryStr);
			}
			strMore += "</ul>";
			strMore += "</td>";
		}
		strMore += "</tr>";
		strMore += "</table>";
		
		
		var spanAltSEMore = document.getElementById("AltSearchEngines_MoreTag");
		if(strMore==""){
			//Hide more/less options:
			spanAltSEMore.style.display = "none";
		}else{
			divAltEnginesMore.innerHTML = strMore;
			spanAltSEMore.style.display = "block";
		}

	},

	keyword_in_query: function(SeObject, queryStr){
		/*
			All keywords are lower case (as dictated when read in from RDF)
			Test all keywords to see if they appear in the querystr.
				Keywords tend to be more lengthy and meaningful, and so are less likely to be found in query str than viceversa.

		*/

		if(!SeObject.regexpKeywordArray){
			return false;
		}
		
		try{
		for(var i = 0; i < SeObject.regexpKeywordArray.length; i++){
			if( SeObject.regexpKeywordArray[i].test( queryStr )==true ){
				return true;
			}
		}
		
		}catch(e){}
		
		return false;
	},
	addSe_ToSeMoreObject: function(SeMore, SeObject){
		/*
			File this search engine in the correct part of SeMore
		*/
		
		if(SeObject.specialisation){
			var specialisationArray = SeObject.specialisation.split(",");
		}else{
			var specialisationArray = ["General"];
		}

		
		for(var i = 0; i < specialisationArray.length; i++){
			var specialisation = specialisationArray[i];

			if( specialisation=="" ){
				specialisation = "General";
			}
			
			if( SeMore[specialisation] ){
				var specialArray = SeMore[specialisation];
				specialArray[specialArray.length] = SeObject.name;
			}
		}
	},
	createStr_Context: function(strContext, SeObject, callBackPrefix, queryStr){
		var newStr = AltSearchEngines.createStr_Shared_Link(SeObject, callBackPrefix, queryStr);
		if(newStr!="") newStr = newStr + "&nbsp;-&nbsp;";
		if(newStr!="") newStr = "<span class='AltSearchEngines_List_Context'>" + newStr + "</span>";
		return strContext + newStr;
	},
	createStr_Primary: function(strPrimary, SeObject, callBackPrefix, queryStr){
		var newStr = AltSearchEngines.createStr_Shared_Link(SeObject, callBackPrefix, queryStr);
		if(newStr!="") newStr = newStr + "&nbsp;-&nbsp;";
		if(newStr!="") newStr = "<span class='AltSearchEngines_List_Primary'>" + newStr + "</span>";
		return strPrimary + newStr
	},
	createStr_More: function(strMore, SeObject, callBackPrefix, queryStr){
		if( !SeObject ){
			return strMore;
		}
		var newStr = AltSearchEngines.createStr_Shared_Link(SeObject, callBackPrefix, queryStr);
		if(newStr!="") newStr = "<li>" + newStr + "</li>";
		return strMore + newStr;
	},
	createStr_Shared_Link: function(SeObject, callBackPrefix, queryStr){
		var newStr = "";
		
		var str_displayName = "";
		var str_title = "";
		if( SeObject.displayName ) str_displayName = SeObject.displayName;
		if( SeObject.title ) str_title = SeObject.title;
		
		if( SeObject.url && SeObject.url!="" ){
			var thisUrl = GtdUtilGeneral.prepQueryUrl(SeObject.url, queryStr);

			newStr = "<a id='GtdGmail_InnerSearch_SeLink_" + SeObject.name + "' href='" + thisUrl + "' title=\"" + str_title + "\" onClick=\"" + callBackPrefix + ".altEngines_seClickHandler('"+ SeObject.name +"', event);\">";
			newStr += str_displayName + "&#187;";
			newStr += "</a>";
		}
		return newStr;
	},



	show_Container: function(){
		/*
			Show the main Inner Search box
		*/
		
		// Get the Container DIV
		var elementDiv = document.getElementById("InnerSearch_Result_Container_Main");		
		// Make the Container-DIV visible:
		
		if(this.bool_UseEffects){
			try{
				Effect.Appear(elementDiv);
			}catch(e){
				elementDiv.style.display = "block";
			}
		}else{
			elementDiv.style.display = "block";
		}
	},
	
	toggleMoreEngines: function(event){
		event.stopPropagation();
		event.preventDefault();
		
		//Get the tag:
		var spanAltSEMore = document.getElementById("AltSearchEngines_MoreTag");
		var divISMore = document.getElementById("AltSearchEngines_More");

		var strMore = this.strLocaleEntities.getString("InnerSearch.AltEngines.MoreLess.More");
		var strLess = this.strLocaleEntities.getString("InnerSearch.AltEngines.MoreLess.Less");

		if(spanAltSEMore.innerHTML.indexOf(strMore)!=-1){
			// Show it
			if(this.bool_UseEffects){
				try{
					Effect.SlideDown(divISMore);
				}catch(e){
					divISMore.style.display = "inline";
				}
			}else{
				divISMore.style.display = "inline";
			}
			spanAltSEMore.innerHTML = "&#171;" + strLess;
		}else{
			if(this.bool_UseEffects){
				try{
					Effect.SlideUp(divISMore);
				}catch(e){
					divISMore.style.display = "none";
				}
			}else{
				divISMore.style.display = "none";
			}
			spanAltSEMore.innerHTML = strMore + "&#187;";
		}

		var elLinks = divISMore.getElementsByTagName("A");
		if(elLinks.length > 0) elLinks[0].focus();		
	},
	
	create_Div_SubTitle: function(callBackPrefix, desiredSeName, queryStr){
		/*
			Scan for child engines
				For each one, create a link
			If child engines found, return containing Div
			If not, return null
		*/
	
		// Create a container to hold sub title together:
		var divContainer = GtdUtilGeneral.createElement("div");
		divContainer.className = "InnerSearchBox_SubTitle";
			

		// Retrieve SeObjects from cache:
		var SearchEngines = GtdUtilGeneral_Local.getGlobals_Overlay().browser_appcontent.GtdShared.SearchEngines;
		
		var elLink;
		var boolHasChild = false;
		for(var i = 0; i < SearchEngines.SeObjects[desiredSeName].childArray.length; i++){
			var seChildName = SearchEngines.SeObjects[desiredSeName].childArray[i];
			var SeObject = SearchEngines.SeObjects[seChildName];
			
			if( SeObject.parentName==desiredSeName && SeObject.displayName && SeObject.url){
				elLink = GtdUtilGeneral.createElement("a");
				elLink.id = "InnerSearch_Box_SubTitle_AltEnginesChildren_Main";
				elLink.href = GtdUtilGeneral.prepQueryUrl(SeObject.url, queryStr);
				if( SeObject.title ){
					elLink.setAttribute("title", SeObject.title);
				}
				elLink.setAttribute("onClick", callBackPrefix + ".altEngines_Child_seClickHandler('" + SeObject.name + "',event)");
				elLink.innerHTML = SeObject.displayName;
				divContainer.appendChild( elLink );
				if( i!=(SearchEngines.SeObjects[desiredSeName].childArray.length - 1) ){
					divContainer.appendChild( document.createTextNode(", ") );
				}
				boolHasChild = true;
			}
		}
				
		if(boolHasChild==true){
			return divContainer;
		}else{
			return null;
		}
		
	}

}















/* ===============================================
	INNER SEARCH - BOX
================================================*/



var InnerSearchBox = {

	strLocaleEntities: GtdUtilGeneral_Local.getGlobals_Overlay().browser_appcontent.GtdShared.OverlayStringBundle,
	
	testFire: function(){
		alert("isb works");
	},
	
	getHTML: function(callBackPrefix, innerSearchId, suppressHide){
		/*
			Generate the inner search box using Javascript
			Populate it with the correct id.
			
			@callBackPrefix - the collection containing the functions, e.g. for hiding the box.
								typically, it'll be a page-specific prefix, e.g. SEI_Google
			@innerSearchId - the id of this box
		*/
		
		var GtdOptions = GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions;
		var transStyle = "";
		if(GtdOptions.getOption("bool", "Performance.Transparency", false)==true){
			// Make it semi transparent:
			transStyle = "-moz-opacity:0.65;";
		}
		
		var iBoxStr = "";
		iBoxStr = iBoxStr + "<div id=InnerSearch_Box_[INNERSEARCHID] class=InnerSearchBox style='height:0px;" + transStyle + "' NoGtdCrossPolli=true>";
		iBoxStr = iBoxStr + "	<div class=InnerSearchBox_Title>";
		iBoxStr = iBoxStr + "		<span id=InnerSearch_Box_Title_[INNERSEARCHID]></span>";
		if(suppressHide!=true){
			iBoxStr = iBoxStr + "		[<span id=InnerSearch_Hide2_[INNERSEARCHID] style='text-align:right;' class=myLink onClick="+callBackPrefix+".InnerSearch_Hide(event)>" + this.strLocaleEntities.getString("InnerSearch.Hide") + "</span>]";
		}
		iBoxStr = iBoxStr + "	</div>";
		iBoxStr = iBoxStr + "	<div id=InnerSearch_Box_SubTitle_[INNERSEARCHID] class=InnerSearchBox_SubTitle style='display:none;'></div>";
		iBoxStr = iBoxStr + "	<div id=InnerSearch_Box_OptionalHookPoint_[INNERSEARCHID] class='InnerSearchBox_Optional' style='display:none;'></div>";
		iBoxStr = iBoxStr + "	<div id=InnerSearch_Box_IFRAMEContainer_[INNERSEARCHID] class=InnerSearchBox_IFrameContainer></div>";
		iBoxStr = iBoxStr + "	<div  class=InnerSearchBox_Base >";
		iBoxStr = iBoxStr + "		<div id=InnerSearch_Box_Base_[INNERSEARCHID] class=InnerSearchBox_Base_Resizer onmousedown='InnerSearchBox.beginVResize(event)'>&nbsp;</div>";
		iBoxStr = iBoxStr + "	</div>";
		iBoxStr = iBoxStr + "</div>";

		iBoxStr = iBoxStr.replace(/\[INNERSEARCHID\]/gi, innerSearchId);

		return iBoxStr;
	},




	getElement_SubTitle_SimilarPages: function(iSearchID, callBackPrefix, queryUrl){
		var divContainer = GtdUtilGeneral.createElement("div");
		try{
		
			// Retrieve SeObjects from cache:
			var SearchEngines = GtdUtilGeneral_Local.getGlobals_Overlay().browser_appcontent.GtdShared.SearchEngines;
			
			divContainer.className = "InnerSearchBox_SubTitle";
			
			queryUrl = GtdUtilGeneral.removeHttpPrefixFromUrl( queryUrl );
			
			var elLink;
			
			// Going to add the similar Pages links as children of the Sub Title
			divContainer.appendChild( document.createTextNode( this.strLocaleEntities.getString("InnerSearch.SimilarPages.Prefix") + " " ) );
			
			//Add Google-Related:
			elLink = GtdUtilGeneral.createElement("a");
			elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_Google_" + iSearchID;
			var googleQueryStr = "related:" + queryUrl;
			googleQueryStr = GtdUtilGeneral.encodeUrl( googleQueryStr );
			elLink.href = SearchEngines.SeObjects.google.url.replace(/\[QUERY\]/g, googleQueryStr);
			elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.GoogleRelated.Tooltip") );
			elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
			elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.GoogleRelated");
			divContainer.appendChild( elLink );
					
			if( SearchEngines.SeObjects.alexa && SearchEngines.SeObjects.alexa.url){
				divContainer.appendChild( document.createTextNode(", ") );
				elLink = GtdUtilGeneral.createElement("a");
				elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_Alexa_" + iSearchID;
				var alexaQueryStr = GtdUtilGeneral.encodeUrl( queryUrl );
				elLink.href = SearchEngines.SeObjects.alexa.url.replace(/\[QUERY\]/g, alexaQueryStr);
				//elLink.href = "chrome://gtdgmail/content/xmlhttphandler.htm?" + GtdUtilGeneral.removeHttpPrefixFromUrl(elLink.href);
				elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.Alexa.Tooltip") );
				elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
				elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.Alexa");
				divContainer.appendChild( elLink );
			}
		

							
			if( SearchEngines.SeObjects.delicious_url && SearchEngines.SeObjects.delicious_url.url){
				divContainer.appendChild( document.createTextNode(", ") );
				elLink = GtdUtilGeneral.createElement("a");
				elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_Delicious_" + iSearchID;
				var deliciousQueryStr = GtdUtilGeneral.encodeUrl( queryUrl );
				elLink.href = SearchEngines.SeObjects.delicious_url.url.replace(/\[QUERY\]/g, deliciousQueryStr);
				elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.Delicious.Tooltip") );
				elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
				elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.Delicious");
				divContainer.appendChild( elLink );
			}
						
			// Back Links:
			var elementSplit = document.createElement("span");
			elementSplit.innerHTML = "&nbsp;";
			
			divContainer.appendChild( elementSplit );
			divContainer.appendChild( document.createTextNode(" (") );
			
			// Google back links:
			elLink = GtdUtilGeneral.createElement("a");
			elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_GoogleBackLink_" + iSearchID;
			googleQueryStr = "link:" + queryUrl;
			googleQueryStr = GtdUtilGeneral.encodeUrl( googleQueryStr );
			elLink.href = SearchEngines.SeObjects.google.url.replace(/\[QUERY\]/g, googleQueryStr);
			elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.GoogleBackLinks.Tooltip") );
			elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
			elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.GoogleBackLinks");
			elLink.style.fontSize = "0.85em";
			divContainer.appendChild( elLink );
			
			/*
			// MSN back links:
			elLink = GtdUtilGeneral.createElement("a");
			elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_MSNBackLink_" + iSearchID;
			googleQueryStr = "link:" + queryUrl;
			googleQueryStr = GtdUtilGeneral.encodeUrl( googleQueryStr );
			elLink.href = SearchEngines.SeObjects.msn.url.replace(/\[QUERY\]/g, googleQueryStr);
			elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.MSNBackLinks.Tooltip") );
			elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
			elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.MSNBackLinks");
			elLink.style.fontSize = "0.85em";
			divContainer.appendChild( elLink );
			*/
			
			// Back Links:
			divContainer.appendChild( document.createTextNode(")") );
			
			
			if( SearchEngines.SeObjects.technorati && SearchEngines.SeObjects.technorati.url){
				var elSpan = document.createElement("span");
				elSpan.innerHTML = ";&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + this.strLocaleEntities.getString("InnerSearch.SimilarPages.Blogs") + " ";
				divContainer.appendChild( elSpan );
				elLink = GtdUtilGeneral.createElement("a");
				elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_Technorati_" + iSearchID;
				var technoratiQueryStr = GtdUtilGeneral.encodeUrl( queryUrl );
				elLink.href = SearchEngines.SeObjects.technorati.url.replace(/\[QUERY\]/g, technoratiQueryStr);
				elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.Technorati.Tooltip") );
				elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
				elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.Technorati");
				divContainer.appendChild( elLink );
			}
		
			if( SearchEngines.SeObjects.sphere && SearchEngines.SeObjects.sphere.url){
				divContainer.appendChild( document.createTextNode(", ") );
				elLink = GtdUtilGeneral.createElement("a");
				elLink.id = "InnerSearch_Box_SubTitle_SimilarPages_Sphere_" + iSearchID;
				var sphereQueryStr = "sphereit:" + GtdUtilGeneral.encodeUrl( queryUrl );
				elLink.href = SearchEngines.SeObjects.sphere.url.replace(/\[QUERY\]/g, sphereQueryStr);
				elLink.setAttribute("title", this.strLocaleEntities.getString("InnerSearch.SimilarPages.Sphere.Tooltip") );
				elLink.setAttribute("onclick", callBackPrefix + ".InnerSearch_SubTitle_SimilarPages_Click(event)");
				elLink.innerHTML = this.strLocaleEntities.getString("InnerSearch.SimilarPages.Sphere");
				divContainer.appendChild( elLink );
			}
			
			
		}catch(e){
			//alert(e.toString())
		}
		
		return divContainer;
	},


	beginVResize: function(event){
		/*
		For the vertical resizing of inner search divs.
		Need to resize containing div
		Need to resize IFRAME
		*/
		
		
		//Extract ID:
		var innerSearchId = InnerSearchBox.extractId(event.currentTarget.id);
		var isResizing = true;

		//Retrieve the elements:
		divContainer = document.getElementById("InnerSearch_Box_"+innerSearchId);
		iframe = document.getElementById("InnerSearch_Box_IFRAME_"+innerSearchId);


		divContainerY = parseInt(divContainer.style.height);
		iframeY = parseInt(iframe.style.height);


		//Offset the numbers:
		divContainerY = event.clientY - divContainerY;
		iframeY = event.clientY - iframeY;


		// Register the handlers that follow mouse:
		document.addEventListener("mousemove", resizeMoveHandler, true);
		document.addEventListener("mouseup", resizeUpHandler, true);
		document.addEventListener("mousedown", resizeUpHandler, true);


		try{
			iframe.contentWindow.document.addEventListener("mousemove", parent.resizeMoveHandler, true);
			iframe.contentWindow.document.addEventListener("mouseup", parent.resizeUpHandler, true);
		}catch(e){}

		
		// Prevent any propagation
		event.stopPropagation();
		event.preventDefault();

		function resizeMoveHandler(event){
			if (isResizing && isResizing==true){
				var deltaDivContainerY = (event.clientY - divContainerY)+"px"
				var deltaIframeY = (event.clientY - iframeY)+"px"

				//iframe.style.height
				if((parseInt(deltaIframeY)>0)||(parseInt(deltaIframeY)>parseInt(iframe.style.height)) ){
					divContainer.style.height = (event.clientY - divContainerY)+"px";
					iframe.style.height = (event.clientY - iframeY)+"px";
				}
				event.stopPropagation();
			}
			else{
				//alert("not me");
			}
		}
		function resizeUpHandler(event){
			isResizing = false;

			// Write new heights to the settings:
			InnerSearchBox.setResizeHeight( divContainer.style.height, iframe.style.height );
						
			document.removeEventListener("mousemove", resizeMoveHandler, true);
			document.removeEventListener("mouseup", resizeUpHandler, true);
			document.removeEventListener("mousedown", resizeUpHandler, true);
			iframe.contentWindow.document.removeEventListener("mousemove", parent.resizeMoveHandler, true);
			iframe.contentWindow.document.removeEventListener("mouseup", parent.resizeUpHandler, true);

			event.stopPropagation();
		}
		
	},


	setResizeHeight: function(newHeightDivContainer, newHeightIFrame){
		/*
			Write to Gtd Options (if available in document) the new height for the inner div.
		*/
		try{
			newHeightDivContainer = parseInt(newHeightDivContainer);
			newHeightIFrame = parseInt(newHeightIFrame);
			
			// Precautionary measures incase the boxes have fallen out of sync (causes overlap).
			if(newHeightIFrame>=newHeightDivContainer){
				newHeightIFrame = (newHeightDivContainer - 50);
				if(newHeightIFrame<0){
					newHeightIFrame = 0;
				}
			}
			
			var GtdOptions = GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions;
			
			try{
				GtdOptions.setOption('int', "gtd_innersearch_divResize_height_container", newHeightDivContainer);
			}catch(e){}
			try{
				GtdOptions.setOption('int', "gtd_innersearch_divResize_height_iframe", newHeightIFrame);
			}catch(e){}
		}catch(e){}
	},
	getResizeHeight_Array: function(){
		/*
			Read from Gtd Options (if available in document) the new height for the inner div and iframe
		*/

		/*
			Verify the height values are legal.
			Neither must be negative, and both must have numeric aspects.

			If either found to be a problem, reset them.
		*/

		try{
			var GtdOptions = GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions;
			var heightDivContainer = GtdOptions.getOption('int', "gtd_innersearch_divResize_height_container", -1);
			var heightIframe = GtdOptions.getOption('int', "gtd_innersearch_divResize_height_iframe", -1);

			heightDivContainer = parseInt(heightDivContainer);
			heightIframe = parseInt(heightIframe);
		}catch(e){}

		if( isNaN(heightDivContainer) || isNaN(heightIframe) || heightDivContainer<0 || heightIframe<0 ){
			heightDivContainer = 400;
			heightIframe = 350;
		}

		return [heightDivContainer, heightIframe];
	},

	extractId: function(fullID){
		// Extracts the portion of the InnerSearch ID after the last _

		var innerSearchId = "";
		var lastUnderscorePos = fullID.lastIndexOf("_");
		if(lastUnderscorePos<0){
			return "";
		}
		innerSearchId = fullID.sugtdtr(lastUnderscorePos+1);

		return innerSearchId;	
	},



	load: function(originalEvent, innerSearchID, title, elementSubTitle, iframeSrc){
		/*
			Load the data of the specified Inner Search.
			Set the title,
				clear and optionally set the sub title
			Retrieve the IFrame, and point it at the correct URL.
			
		*/
		

		// Get the specified element:
		var elementInnerSearchBox = document.getElementById("InnerSearch_Box_" + innerSearchID);
		if(!elementInnerSearchBox){
			// abort
			return;
		}

		// Set the title:
		var divIsmTitle = document.getElementById("InnerSearch_Box_Title_" + innerSearchID);
		divIsmTitle.innerHTML = title;
		
		// Set the sub title:
		this.setSubTitleElement( innerSearchID, elementSubTitle );
		
		// Retrieve height of the inner search:
		var divContainer = document.getElementById("InnerSearch_Box_"+innerSearchID);
		divContainer.style.height = InnerSearchBox.getResizeHeight_Array()[0] + "px";
		
		var firstLoad = false;
		if( InnerSearchBox.getIFrameSrc(innerSearchID)=="" ){
			firstLoad = true;
		}
		
		// Handle the loading of the IFRAME:
		InnerSearchBox.setIFrame(innerSearchID, iframeSrc);
		
		
		if( firstLoad==true ){
			/*
				Initiate a click event again.
				Why? Well, only since adding about:blank redirects (that ethically mask the referrer to other sites), InnerSearch box would not load on first click.
				Presumably, this is a security setting (inspired by about:blank virus)
					Whereby it will only load and process an about:blank iframe in response to a click
					(and the first click creates the IFrame)
			*/
			try{
				setTimeout("GtdUtilGeneral.simulateLinkClick('" + originalEvent.target.id + "')", 50);
			}catch(e){}
		}
		

	},
	
	setSubTitleElement: function( innerSearchID, elementSubTitle ){
		/*
			Attach a sub title element to the DIV of choice.
		*/
		
		var divIsmSubTitle = document.getElementById("InnerSearch_Box_SubTitle_" + innerSearchID);
		// Remove anything under the title:
		if(divIsmSubTitle.hasChildNodes()){
			for(var i = divIsmSubTitle.childNodes.length - 1; i >= 0; i--){
				try{
					divIsmSubTitle.removeChild( divIsmSubTitle.childNodes[i] );
				}catch(e){}
			}
		}
		// Add new sub title:
		if(elementSubTitle==null){
			divIsmSubTitle.style.display = "none";
		}else{
			divIsmSubTitle.style.display = "block";
			divIsmSubTitle.appendChild( elementSubTitle );
		}
		
	},


	setIFrame: function(innerSearchID, iframeUrl){
		/*
			IFrames are late-loaded, as they are resource hungry, and can cause issues with the Back button.
			
			If no IFRAME attached to container; it builds one.
			Then it sets the IFRAME src to iframeUrl.
		*/

		// Try and retrieve existing Iframe:
		var iframe = document.getElementById("InnerSearch_Box_IFRAME_" + innerSearchID);

		
		if(iframe==null){
			// Create new Iframe:
			iframe = GtdUtilGeneral.createElement("iframe");
			iframe.id = "InnerSearch_Box_IFRAME_" + innerSearchID;
			iframe.style.height = InnerSearchBox.getResizeHeight_Array()[1] + "px";
			iframe.style.width = "97%";
			iframe.className = "InnerSearchBox_IFrame";

			// Get IFrame container
			var iframeContainer = document.getElementById("InnerSearch_Box_IFRAMEContainer_" + innerSearchID);
			iframeContainer.appendChild(iframe);
		}


		/*
			Modify URL
			Need to add identify to know it's inner frame.
			If url contains ?, then add '&'
			If url does not contain ?, then add ?

			With flag, gtdInnerSIF=true
		*/
		//var pageId = GtdUtilGeneral_Local.getGlobals_Overlay().gtdPageId;

		if (iframeUrl.indexOf("?")==-1){
			// No ?
			iframeUrl += "?gtdInnerSIF=true";// + pageId; <- IF PUT BACK IN, ALSO PUT IN BELOW
		}else{
			// insert immediately after the ?:
			var indexPos = iframeUrl.indexOf("?");
			iframeUrl = iframeUrl.sugtdtr(0, indexPos + 1) + "gtdInnerSIF=true" + "&" + iframeUrl.sugtdtr(indexPos + 1);
		}
		
		/*
			We use a special redirector to prevent strange referrers upsetting the logs of wegtdites we link to
		*/
		iframeUrl = "about:blank?GtdGmail=" + iframeUrl;
							
		// Now set the src
		
		try{
			iframe.src = iframeUrl;
		}
		catch(e){}
		
	},

	getIFrameSrc: function(innerSearchID){
		var iframe = document.getElementById("InnerSearch_Box_IFRAME_" + innerSearchID);
		
		if( !iframe || !iframe.src ){
			return "";
		}
		
		return iframe.src;
	},

	setIFrameBlank: function(innerSearchID){
		var iframe = document.getElementById("InnerSearch_Box_IFRAME_" + innerSearchID);
		
		try{
			iframe.src = "about:blank";
		}
		catch(e){}
	},
	
	removeIFrame: function(innerSearchID){
		var iframe = document.getElementById("InnerSearch_Box_IFRAME_" + innerSearchID);
		
		try{
			iframe.parentNode.removeChild(iframe);
		}
		catch(e){}
	}

}