/*

	Bumble Search
	(c) 2005 2006 Andy Mitchell [andy@bumblesearch.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@bumblesearch.com]'
	It is also a requirement to place the url, http://www.bumblesearch.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in new projects.

*/





var gtdOptions = new GtdGmailOptions();

var localeEntities;

var ToSaveObj = new Object();
ToSaveObj.KeyArray = new Array();


var changedKeys = false;

function initialise(idWindow){
	/*
		Configure the window to listen for checkboxes changing
	*/
	
	
	elWindowId = document.getElementById(idWindow);
	
	//elWindowId.addEventListener("ValueChange", saveOptionUsingEvent, false);
	
	elWindowId.addEventListener("CheckboxStateChange", saveOptionUsingEvent, false);
	
	// Configure for text box changes
	// Currently on every text change; could be done to be 'onblur' (with combo of full save on window unload)
	var docTextBoxes = elWindowId.getElementsByTagName("textbox");
	for(var i = 0; i < docTextBoxes.length; i++){
		var elTextBox = docTextBoxes[i];
		elTextBox.addEventListener("input", saveOptionUsingEvent, false);
	}
	
	
	var ComboElements = elWindowId.getElementsByTagName("menulist");
	for(var j = 0; j < ComboElements.length; j++){
		ComboElements[j].addEventListener("ValueChange", ComboOption_Save, false);
	}
	
	var ComboStyles = document.getElementById("ComboStyles");	
	// Add the event listener for a change:
	ComboStyles.addEventListener("ValueChange", ComboStyles_ValueChange, false);
	// Set last option:
	ComboStyles.selectedItem = document.getElementById(gtdOptions.getOption("char", "GTDGmail.GTDStyle", "TheEmptyInboxer"))
	
	setTimeout("loadIframes();", 500);
	
	
	
	// Last:
	loadOptions(idWindow);
}

function ComboStyles_ValueChange(){							
	try{
		var ElStyles = ["The Empty Inbox","The Archive Graveyard","I Love My Inbox"];
		
		// Hide all previous
		try{
			for( var i = 0; i < ElStyles.length; i++ ){
				document.getElementById(ElStyles[i]).style.display = "none";
			}
		}catch(e){}
		
		// Show the current one:
		var ComboStyles = document.getElementById("ComboStyles");
		document.getElementById( ComboStyles.selectedItem.label ).style.display = "";
		try{
			switch(ComboStyles.selectedItem.label){
				case "The Archive Graveyard":
					document.getElementById("GTDGmail.FinishMoveToArchive").checked = true;
					document.getElementById("GTDGmail.SearchStr.OnlyInbox").checked = true;
					break;
				case "The Empty Inbox":
					document.getElementById("GTDGmail.FinishMoveToArchive").checked = false;
					document.getElementById("GTDGmail.SearchStr.OnlyInbox").checked = false;
					break;
				case "I Love My Inbox":
					document.getElementById("GTDGmail.FinishMoveToArchive").checked = false;
					document.getElementById("GTDGmail.SearchStr.OnlyInbox").checked = true;
					break;
			}
		}catch(e){
			//alert(e.toString());
		}
		
		gtdOptions.setOption("char", "GTDGmail.GTDStyle", ComboStyles.selectedItem.id);
		
	}catch(e){
		//alert(e.toString());
	}
}

function loadIframes(){
	var elIframe = document.getElementById("iframeNews");
	try{
		elIframe.setAttribute("src", "http://www.gtdgmail.com/directaccess/news/");
	}catch(e){}
	
	var elIframe = document.getElementById("iframeTeam");
	try{
		elIframe.setAttribute("src", "http://www.gtdgmail.com/directaccess/team/");
	}catch(e){}
	
	
	var elIframe = document.getElementById("iframeFaqSupport");
	try{
		elIframe.setAttribute("src", "http://www.gtdgmail.com/directaccess/support/");
	}catch(e){}
	
}

function saveOptions(idWindow){
	/*
		Read all elements with the attribute 'isPref', and write their values to the datastore.
	*/
	
	
	elWindowId = document.getElementById(idWindow);
	optionsElements = document.getElementsByAttribute("isPref", "*");
	
	for(var i = 0; i < optionsElements.length; i++){
		saveOption(optionsElements[i]);
	}
}

function saveOptionUsingEvent(evt){
	/*
		Retrieve the element.
	*/
	
	var element = evt.target;
	
	if(element){
		saveOption(element);
	}
}

function ComboOption_Save(evt){
	var element = evt.target;
		
	if(element){
		saveOption(element);
	}
}

function saveOption(element){
	/*
		Save only the specific element
		
		1) Discover nature of element (checkbox, textbox, etc.)
			Specify type
			Extract data
		2) Write to store
	*/
	
	if( !element.getAttribute("isPref") || element.getAttribute("isPref")=="" ){
		// It's not an option
		return;
	}
	
	var prefKey = element.getAttribute("id");
	
	if(prefKey.indexOf("GlobalKeys")!=-1){
		// Contains a key change. Notify system of key change.
		// Why? Damn FF crashes if 'Apply Now' too much, because of updating the keys.
		// So, only update keys if they agtdolutely change.
		changedKeys = true;
	}
	
	var prefType = "";
	var prefValue = "";
	try{
		switch(element.localName){
			case "checkbox":
				prefType = "bool";
				prefValue = element.checked;
				break;
			case "textbox":
				prefType = "text";
				prefValue = element.value;
				
				/*
				if( prefValue=="" ){
					alert("This value cannot be nothing!");
					prefValue = gtdOptions.getOption(prefType, prefKey, "");
					element.value = prefValue;
					return;
				}
				if( element.hasAttribute("numericDefault") && isNaN(element.value) ){
					alert("This value must be numeric!");
					prefValue = gtdOptions.getOption(prefType, prefKey, "");
					element.value = prefValue;
				}
				*/
				break;
			case "menulist":
				// Scan the under DOM for the selected item.
				prefType = "char";
				prefValue = element.selectedItem.getAttribute("value");
				break;
			default:
				return;
		}
	}
	catch(e){return;}
	
	try{
	// See if this key is in the ToSave object
	var found = false;
	for( var i = 0; i < ToSaveObj.KeyArray.length; i++ ){
		if( ToSaveObj.KeyArray[i]==prefKey ){
			found = true;
			break;
		}
	}
	if( !found ){
		// Add it
		ToSaveObj.KeyArray[ToSaveObj.KeyArray.length] = prefKey;
		ToSaveObj.KeyArray[prefKey] = new Object();
	}
	// Update:
	ToSaveObj.KeyArray[prefKey].type = prefType;
	ToSaveObj.KeyArray[prefKey].val = prefValue;
	}catch(e){
		//alert(e.toString());
	}
	
	//gtdOptions.setOption(prefType, prefKey, prefValue);
}
function writeAllSaved(){
	/*
		Process the saved values and write them to the options
	*/
	try{
		for( var i = 0; i < ToSaveObj.KeyArray.length; i++ ){
			var prefKey = ToSaveObj.KeyArray[i];
			
			if( !(ToSaveObj.KeyArray[prefKey].type=="text" && ToSaveObj.KeyArray[prefKey].val=="") ){
				gtdOptions.setOption(ToSaveObj.KeyArray[prefKey].type, prefKey, ToSaveObj.KeyArray[prefKey].val);
			}
		}
	}catch(e){
		//alert(e.toString());
	}
}

function loadOptions(idWindow){
	/*
		Read all elements with attribute 'prefKey', and read in the value from the datastore for each one.
	*/
	
	elWindowId = document.getElementById(idWindow);
	optionsElements = document.getElementsByAttribute("isPref", "*");
	
	
	var prefKey = "";
	var prefType = "";
	var prefValue = "";
	var prefDefault = "";
	
	var element;
	for(var i = 0; i < optionsElements.length; i++){
		element = optionsElements[i];
		prefKey = element.getAttribute("id");
		prefDefault = element.getAttribute("prefDefault");
		
		
		try{
			switch(element.localName){
				case "checkbox":
					prefType = "bool";
					prefValue = gtdOptions.getOption(prefType, prefKey, prefDefault);
					element.checked = prefValue;
					break;
				case "textbox":
					prefType = "char";
					prefValue = gtdOptions.getOption(prefType, prefKey, prefDefault);
					element.value = prefValue;
					break;
				case "menulist":
					prefType = "char";
					prefValue = gtdOptions.getOption(prefType, prefKey, prefDefault);
					// Seek out the correct child, and mark it selected
					var menuItemElements = element.getElementsByTagName("menuitem");
					for(var j = 0; j < menuItemElements.length; j++){
						if( menuItemElements[j].getAttribute("value")==prefValue ){
							//element.setAttribute("label", menuItemElements[j].getAttribute("label") );
							//menuItemElements[j].setAttribute("selected", "true");
							element.selectedItem = menuItemElements[j];
							break;
						}
					}
					break;
				default:
					break;
			}
		}
		catch(e){
			//alert("failed load: \n" + e.toString());
		}
	}
}