/*

	Gtd Gmail
	(c) 2005 2006 Andy Mitchell [andy@gtdgmail.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@gtdgmail.com]'
	It is also a requirement to place the url, http://www.gtdgmail.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in hearing of new projects.


*/


var Print_Hipster_PDA = {

	SharedObj: null,
	InboxData: null,
	
	INCH_TO_PIXEL: 96,
	cardHeight_Inch: 0,
	cardHeight_Pixel: 0,
	currentPage_Pixels: 0,
	
	prefixStatus: "",
	
	testFire: function(){
		alert("123");
	},
	

	injectIntoPage: function(){
		/*
			The handling function for the entire process
			See what page we have (Based on the elements within it) and delegate accordingly
		*/
		
		try{
		
		
			// Inject the CSS:
			//this.injectCSS("chrome://gtdgmail/content/print_hipster_pda.css");
			
			// Create/Retrieve the Shared Object (for all iframes):
			var emailAddress = GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions.getOption("char", "CurrentEmailAddress", "");
			if( document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail && document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail[emailAddress] ){
				this.SharedObj = document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail[emailAddress];
			}
			if( !this.SharedObj ){
				this.SharedObj = document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail;
			}
			if( !this.SharedObj ){
				this.renderError("Gmail did not pass any information to this window.");
				return;
			}
						
			this.prefixStatus = this.SharedObj.LabelTypesObj.Status.prefix;
			
			// Fetch the Inbox Data object
			this.InboxData = this.SharedObj.InboxData;
			if( !this.InboxData ){
				this.renderError("Gmail did not pass any Inbox/Email information to this window.");
				return;
			}
			
			/*
				Now choose an action, based on what is in shared memory
				SharedObj.PrintHipster.layoutName|doPrint
			*/
			if( this.SharedObj.PrintHipster ){
				switch( this.SharedObj.PrintHipster.layoutName ){
					case "context":
						this.processByContext(this.SharedObj.PrintHipster.subLayoutName);
						break;
					case "project":
						this.processByProject(this.SharedObj.PrintHipster.subLayoutName);
						break;
					case "item":
						this.processByItem();
						break;
					case "status":
						this.processByStatus();
						break;
				}
				
				
				if( this.SharedObj.PrintHipster.doPrint==true ){
					// Print it
					print();
				}
			}

			
			
		}catch(e){
			this.renderError("An unknown error occured.");
			//alert(e.toString());
		}
		
	},
	
	processByContext: function(restrictionStr){
		/*
			Using the InboxData object:
			For each context
				For each status
					Retrieve Emails by Context/Status
					Render them
		*/
		
		//this.renderHeader();		
		var ContextsArray = this.InboxData.getContexts();
		
		for( var i = 0; i < ContextsArray.length; i++ ){
			if( restrictionStr=="" || restrictionStr==ContextsArray[i] ){
				if( i > 0 ){
					this.renderSpacer_MainSection();
				}
				var StatusObj = this.InboxData.getStatusesByContextOrProject( ContextsArray[i], "");			
				this.renderMainSection( ContextsArray[i] );
				this.processStatuses( StatusObj, true );						
			}
		}		
		document.body.innerHTML += " ";
	},
	
	processByProject: function(restrictionStr){
		/*
			Using the InboxData object:
			For each project
				For each status
					Retrieve Emails by Context/Status
					Render them
		*/
		
		//this.renderHeader();		
		var ProjectsArray = this.InboxData.getProjects();
		
		for( var i = 0; i < ProjectsArray.length; i++ ){
			if( restrictionStr=="" || restrictionStr==ProjectsArray[i] ){
				if( i > 0 ){
					this.renderSpacer_MainSection();
				}
				var StatusObj = this.InboxData.getStatusesByContextOrProject( "", ProjectsArray[i]);			
				this.renderMainSection( ProjectsArray[i] );
				
				this.processStatuses( StatusObj, false, true );
			}
		}		
		document.body.innerHTML += " ";
	},
	
	processByItem: function(){
		/*
			Using the InboxData object:
			For each status
				Retrieve Emails by Context/Status
				Render them
		*/
		
		//this.renderHeader();		
		var EmailIdsArray = this.InboxData.getEmailIds();
		
		for( var i = 0; i < EmailIdsArray.length; i++ ){
			if( i > 0 ){
				this.renderSpacer_MainSection();
			}

			this.renderEmailItem( EmailIdsArray[i], true, true, true );
		}
		document.body.innerHTML += " ";
	},
	
	processByStatus: function(){
		/*
			Using the InboxData object:
			For each status
				Retrieve Emails by Context/Status
				Render them
		*/
		
		//this.renderHeader();		
		
		var StatusObj = this.InboxData.getStatusesByContextOrProject( "", "");
		
		// No Misc. items (meaningless in this sense)
		StatusObj.Misc = null;	
		
		this.processStatuses( StatusObj, true, true );
		
		document.body.innerHTML += " ";
		
	},
	
	processStatuses: function(StatusObj, bool_EmailItem_project, bool_EmailItem_context, bool_EmailItem_status){
		// Process Statuses in Preferred Order (remove any FoundStatuses)
		for( var j = 0; j < this.SharedObj.StandardLabels.Status.StatusArray.length; j++ ){
			var statusId = this.SharedObj.StandardLabels.Status.StatusArray[j];
			var statusLbl = this.SharedObj.StandardLabels.Status[statusId];
			if( StatusObj[statusLbl] ){
				if( j > 0 ){
					this.renderSpacer_SubSection();
				}
				
				// Render Status Heading
				this.renderSubSection( statusLbl );
				
				// Process all the emails
				var EmailIdsArray = StatusObj[statusLbl];
				for( k = 0; k < EmailIdsArray.length; k++ ){	
					if( k > 0 ){
						this.renderSpacer_Item();
					}
									
					// Render Email
					this.renderEmailItem( EmailIdsArray[k], bool_EmailItem_project, bool_EmailItem_context, bool_EmailItem_status );
				}					
				// Remove this Status from the Context, so it is not processed again:
				StatusObj[statusLbl] = null;
				
			}
		}
		
		
				
		// Now process all remaining Statuses in .FoundStatusesArray
		for( var j = 0; j < StatusObj.FoundStatusesArray.length; j++ ){
			var statusLbl = StatusObj.FoundStatusesArray[j];
			if( StatusObj[statusLbl] ){	
				if( j > 0 ){
					this.renderSpacer_SubSection();
				}
				
				// Render Status Heading
				this.renderSubSection( statusLbl );
				
				// Process all the emails
				var EmailIdsArray = StatusObj[statusLbl];
				for( k = 0; k < EmailIdsArray.length; k++ ){
					if( k > 0 ){
						this.renderSpacer_Item();
					}
					// Render Email
					this.renderEmailItem( EmailIdsArray[k], bool_EmailItem_project, bool_EmailItem_context, bool_EmailItem_status );
				}					
			}
		}
	},
	
	
	
	
	
	
	
	

	
	renderHeader: function(){
		/*
			Create a header (e.g. for a new card)
			
		*/
					
		var ContextsArray = this.InboxData.getContexts();
		var ProjectsArray = this.InboxData.getProjects();
		
		// Line:
		var ElDiv = document.createElement("div");
		ElDiv.className = "Line";
		ElDiv.innerHTML = "<hr/>";
		document.body.appendChild(ElDiv);
		
		var innerHTML = "";
		innerHTML += "<div class='Heading'>";
		innerHTML += "	<div id='HeadingCategory_Contexts' class='HeadingCategory'></div>";
		innerHTML += "	<div id='Heading_Contexts'></div>";
		innerHTML += "</div>";
		innerHTML += "<div class='Heading'>";
		innerHTML += "	<div id='HeadingCategory_Projects' class='HeadingCategory'></div>";
		innerHTML += "	<div id='Heading_Projects'></div>";
		innerHTML += "</div>";
		
		// Contexts:
		var ElDivHeading = document.createElement("DIV");
		ElDivHeading.className = "Heading";
		document.body.appendChild(ElDivHeading);
		
			// Category:
			var ElDivHeadingChild = document.createElement("DIV");
			ElDivHeadingChild.className = "HeadingCategory";
			if( ContextsArray.length > 1 ){
				ElDivHeadingChild.innerHTML	= "Contexts:";
			}else{
				ElDivHeadingChild.innerHTML	= "Context:";
			}
			ElDivHeading.appendChild( ElDivHeadingChild );
			
			// Context Items
			var ElDivHeadingChild = document.createElement("DIV");		
			for( var i = 0; i < ContextsArray.length; i++ ){
				if( i > 0 ){
					ElDivHeadingChild.innerHTML += ", ";
				}
				ElDivHeadingChild.innerHTML += ContextsArray[i];
			}
			ElDivHeading.appendChild( ElDivHeadingChild );
	
		// Projects:
		var ElDivHeading = document.createElement("DIV");
		ElDivHeading.className = "Heading";
		document.body.appendChild(ElDivHeading);
		
			// Category:
			var ElDivHeadingChild = document.createElement("DIV");
			ElDivHeadingChild.className = "HeadingCategory";
			if( ContextsArray.length > 1 ){
				ElDivHeadingChild.innerHTML	= "Projects:";
			}else{
				ElDivHeadingChild.innerHTML	= "Project:";
			}
			ElDivHeading.appendChild( ElDivHeadingChild );
			
			// Context Items
			var ElDivHeadingChild = document.createElement("DIV");		
			for( var i = 0; i < ProjectsArray.length; i++ ){
				if( i > 0 ){
					ElDivHeadingChild.innerHTML += ", ";
				}
				ElDivHeadingChild.innerHTML += ProjectsArray[i];
			}
			ElDivHeading.appendChild( ElDivHeadingChild );
	
		
		// Line:
		var ElDiv = document.createElement("div");
		ElDiv.className = "Line";
		ElDiv.innerHTML = "<hr/>";
		document.body.appendChild(ElDiv);
	},
	
	
	
	renderMainSection: function(text){
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "MainSection";
		ElDiv.innerHTML = "<hr/>" + text + "<hr/>";
		document.body.appendChild(ElDiv);
	},
	renderSubSection: function(text){
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "SubSection";
		ElDiv.innerHTML = text;
		document.body.appendChild(ElDiv);
	},
	renderEmailItem: function(emailId, bool_project, bool_context, bool_status){
		// Retrieve the email obj
		var EmailObj = this.InboxData.EmailData[emailId];
		if( !EmailObj) return;
		
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "Item";
			// Subject
			var ElDivChild = document.createElement("DIV");
			ElDivChild.className = "ItemSubject";
			ElDivChild.innerHTML = EmailObj.subject;
			if(EmailObj.hasStar==true){
				ElDivChild.innerHTML = "<img src='chrome://gtdgmail/content/star_on.gif' />" + ElDivChild.innerHTML;
			}
			ElDiv.appendChild( ElDivChild );
			
			// Email Intro
			var ElDivChild = document.createElement("DIV");
			ElDivChild.className = "ItemEmailIntro";
			ElDivChild.innerHTML = EmailObj.emailIntro;
			ElDiv.appendChild( ElDivChild );
	
			if( bool_project && EmailObj.ProjectsArray.length > 0 ){
				// Projects
				var ElDivChild = document.createElement("DIV");
				ElDivChild.className = "ItemLabels";
				var innerHTML = "<i>Projects:</i> ";
				for( var ii = 0; ii < EmailObj.ProjectsArray.length; ii++ ){
					if( ii > 0 ){
						innerHTML += ", ";
					}
					innerHTML += EmailObj.ProjectsArray[ii];
				}
				ElDivChild.innerHTML = innerHTML;
				ElDiv.appendChild( ElDivChild );
			}
			
			if( bool_context && EmailObj.ContextsArray.length > 0 ){
				// Contexts
				var ElDivChild = document.createElement("DIV");
				ElDivChild.className = "ItemLabels";
				var innerHTML = "<i>Contexts:</i> ";
				for( var ii = 0; ii < EmailObj.ContextsArray.length; ii++ ){
					if( ii > 0 ){
						innerHTML += ", ";
					}
					innerHTML += EmailObj.ContextsArray[ii];
				}
				ElDivChild.innerHTML = innerHTML;
				ElDiv.appendChild( ElDivChild );
			}
			
			if( bool_status && EmailObj.StatusesArray.length > 0 ){
				// Statuses
				var ElDivChild = document.createElement("DIV");
				ElDivChild.className = "ItemLabels";
				var innerHTML = "<i>Statuses:</i> ";
				for( var ii = 0; ii < EmailObj.StatusesArray.length; ii++ ){
					if( ii > 0 ){
						innerHTML += ", ";
					}
					innerHTML += EmailObj.StatusesArray[ii];
				}
				ElDivChild.innerHTML = innerHTML;
				ElDiv.appendChild( ElDivChild );
			}
		
		document.body.appendChild( ElDiv );
	},
	
	renderSpacer_MainSection: function(){
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "SpacerMainSection";
		ElDiv.innerHTML = "&nbsp;";
		document.body.appendChild(ElDiv);
	},
	renderSpacer_SubSection: function(){
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "SpacerSubSection";
		ElDiv.innerHTML = "&nbsp;";
		document.body.appendChild(ElDiv);
	},
	renderSpacer_Item: function(){
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "SpacerItem";
		ElDiv.innerHTML = "&nbsp;";
		document.body.appendChild(ElDiv);
	},
	
	renderError: function(errorMsg){
		/*
			Clear out the document
			Render the error.
		*/
		
		var ElDiv = document.createElement("DIV");
		ElDiv.className = "error";
		ElDiv.innerHTML = "There was a problem loading the Hipster PDA Card.<br/><br/>" + errorMsg;
		document.body.appendChild(ElDiv);		
	},
	
	
	
	
	
	
	
	getElementHeight: function(El){
		/*
			Retrieve the class name from the Element
			Look this classname up in the style sheet
			Retrieve its height and return it.
		*/
		
		if( El.style.height ){
			return this.getElementHeight_ExtractNumber(El.style.height);
		}
		
		var className = El.className;
		if( className=="" ) return 0;

		var cssRules = document.styleSheets[0].cssRules;
		
		for( var ii = 0; ii < cssRules.length; ii++){
			//cssRules[i].selectorText
			
			if( cssRules[i].selectorText==className ){
				if( cssRules.style.height ){
					return this.getElementHeight_ExtractNumber(cssRules.style.height);
				}
			}
		}
		
		return 0;
		
	},
	getElementHeight_ExtractNumber: function(heightStr){
		return heightStr.replace(/[\D]/g, "");
	}
}









var Print_Hipster_PDA_Header = {
	
	SharedObj: null,
	InboxData: null,
	currentLayout: "",

	injectIntoPage: function(){
		/*
			Retrieve the last Layout used from options
				Retrieve the associated Element
					Make it bold
					Load the appropriate context
		*/
		try{
			// Create/Retrieve the Shared Object (for all iframes):
			var emailAddress = GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions.getOption("char", "CurrentEmailAddress", "");
			if( document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail && document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail[emailAddress] ){
				this.SharedObj = document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail[emailAddress];
			}
			if( !this.SharedObj ){
				this.SharedObj = document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail;
			}
			if( !this.SharedObj ){
				this.renderError("Gmail did not pass any information to this window.");
				return;
			}
			
			this.InboxData = this.SharedObj.InboxData;
			
			// Retrieve the last option
			var lastLayout;
			lastLayout = this.SharedObj.Options.getOption("char", "GTD.PrintHipster.lastLayout", "nothing");
			
			
			var ElLink = document.getElementById(lastLayout);
			if( !ElLink ){
				// Could not find, get the first element
				var ElLinks = document.getElementById("LayoutLinks");
				//alert(ElLinks.childNodes[1].nodeName);
				ElLink = ElLinks.childNodes[1];
			}
			this.clickHandler_LayoutSelect( ElLink );
			
		}catch(e){
			//alert(e.toString());
		}
		
	},
	
	unboldenAll: function(){
		// Make all Layout Links non-bold
		
		var ElLinks = document.getElementById("LayoutLinks");
		
		for( var i = 0; i < ElLinks.childNodes.length; i++){
			if( ElLinks.childNodes[i].style ){
				ElLinks.childNodes[i].style.fontWeight = "";
			}
		}
	},
	
	clickHandler_LayoutSelect: function(El){
		/*
			Load the layout
			
			Bolden the current selection
			Load any sub links needed (All.. <context>...)
		*/
		
		this.unboldenAll();
		El.style.fontWeight = "bold";
		
		this.loadLayout( El.id, false );	
		
		
		// Sub Links:
		if( this.InboxData ){
			var ElSubLinks = document.getElementById("LayoutLinks_Sub");
			ElSubLinks.innerHTML = "";
			var linkTemplateStr = "<a href='' onclick=\"Print_Hipster_PDA_Header.clickHandler_SubLayoutSelect('!SUB!');return false;\">!TEXT!</a>";
			
			var innerHTML = "";
			
			// Contexts
			if( this.SharedObj.PrintHipster.layoutName=="context" ){
				var ContextsArray = this.InboxData.getContexts();
				for( var i = 0; i < ContextsArray.length; i++ ){
					var str = ContextsArray[i];
					innerHTML += " - " + linkTemplateStr.replace(/!SUB!/g, str).replace(/!TEXT!/g, str);
				}
			}
			// Projects
			if( this.SharedObj.PrintHipster.layoutName=="project" ){
				var ProjectsArray = this.InboxData.getProjects();
				for( var i = 0; i < ProjectsArray.length; i++ ){
					var str = ProjectsArray[i];
					innerHTML += " - " + linkTemplateStr.replace(/!SUB!/g, str).replace(/!TEXT!/g, str);
				}
			}
			
			if( innerHTML!="" ){
				innerHTML = linkTemplateStr.replace(/!SUB!/g, "").replace(/!TEXT!/g, "All") + innerHTML;
				innerHTML = "(" + innerHTML + ")";
			}
			
			
			ElSubLinks.innerHTML = innerHTML;
		}
			
	},
	
	clickHandler_SubLayoutSelect: function(subLayout){
		this.SharedObj.PrintHipster.subLayoutName = subLayout;
		parent.frames[1].location.href = "chrome://gtdgmail/content/print_hipster_pda.htm";	
	},
	
	clickHandler_Print: function(){
		this.SharedObj.PrintHipster.doPrint = true;
		parent.frames[1].location.href = "chrome://gtdgmail/content/print_hipster_pda.htm";	
	},
	
	loadLayout: function(layoutName, bool_Print){
		/*
			Bolden this link
			Save to options
			
			Put the layout name and print setting into shared memory
			Reload the frame page
		*/
		
		// Write to options
		this.SharedObj.Options.setOption("char", "GTD.PrintHipster.lastLayout", layoutName);
		
		// Load into shared memory:
		if( !this.SharedObj.PrintHipster ){
			this.SharedObj.PrintHipster = new Object();
		}
		this.SharedObj.PrintHipster.layoutName = layoutName;
		this.SharedObj.PrintHipster.subLayoutName = "";
		this.SharedObj.PrintHipster.doPrint = bool_Print;
				
		parent.frames[1].location.href = "chrome://gtdgmail/content/print_hipster_pda.htm";		
		
	},

}